{-# OPTIONS_GHC -fglasgow-exts #-}

module Ta where {

import qualified Nat;

data Color = R | B deriving (Read, Show);

data Rbt a b = Empty | Tr Color (Rbt a b) a b (Rbt a b) deriving (Read, Show);

data Ta_rule a b = Rule a b [a] deriving (Read, Show);

lhs :: forall a b. Ta_rule a b -> a;
lhs (Rule q l qs) = q;

leta :: forall b a. b -> (b -> a) -> a;
leta s f = f s;

class Orda a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

hd :: forall a. [a] -> a;
hd (x : xs) = x;

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x : xs) = xs;

suc :: Nat.Nat -> Nat.Nat;
suc n = n + 1;

balance :: forall a b. Rbt a b -> a -> b -> Rbt a b -> Rbt a b;
balance (Tr R a w x b) s t (Tr R c y z d) =
  Tr R (Tr B a w x b) s t (Tr B c y z d);
balance (Tr R (Tr R a w x b) s t c) y z Empty =
  Tr R (Tr B a w x b) s t (Tr B c y z Empty);
balance (Tr R (Tr R a w x b) s t c) y z (Tr B va vb vc vd) =
  Tr R (Tr B a w x b) s t (Tr B c y z (Tr B va vb vc vd));
balance (Tr R Empty w x (Tr R b s t c)) y z Empty =
  Tr R (Tr B Empty w x b) s t (Tr B c y z Empty);
balance (Tr R (Tr B va vb vc vd) w x (Tr R b s t c)) y z Empty =
  Tr R (Tr B (Tr B va vb vc vd) w x b) s t (Tr B c y z Empty);
balance (Tr R Empty w x (Tr R b s t c)) y z (Tr B va vb vc vd) =
  Tr R (Tr B Empty w x b) s t (Tr B c y z (Tr B va vb vc vd));
balance (Tr R (Tr B ve vf vga vha) w x (Tr R b s t c)) y z (Tr B va vb vc vd) =
  Tr R (Tr B (Tr B ve vf vga vha) w x b) s t (Tr B c y z (Tr B va vb vc vd));
balance Empty w x (Tr R b s t (Tr R c y z d)) =
  Tr R (Tr B Empty w x b) s t (Tr B c y z d);
balance (Tr B va vb vc vd) w x (Tr R b s t (Tr R c y z d)) =
  Tr R (Tr B (Tr B va vb vc vd) w x b) s t (Tr B c y z d);
balance Empty w x (Tr R (Tr R b s t c) y z Empty) =
  Tr R (Tr B Empty w x b) s t (Tr B c y z Empty);
balance Empty w x (Tr R (Tr R b s t c) y z (Tr B va vb vc vd)) =
  Tr R (Tr B Empty w x b) s t (Tr B c y z (Tr B va vb vc vd));
balance (Tr B va vb vc vd) w x (Tr R (Tr R b s t c) y z Empty) =
  Tr R (Tr B (Tr B va vb vc vd) w x b) s t (Tr B c y z Empty);
balance (Tr B va vb vc vd) w x (Tr R (Tr R b s t c) y z (Tr B ve vf vga vha)) =
  Tr R (Tr B (Tr B va vb vc vd) w x b) s t (Tr B c y z (Tr B ve vf vga vha));
balance Empty s t Empty = Tr B Empty s t Empty;
balance Empty s t (Tr B va vb vc vd) = Tr B Empty s t (Tr B va vb vc vd);
balance Empty s t (Tr B va vb vc Empty) = Tr B Empty s t (Tr B va vb vc Empty);
balance Empty s t (Tr v Empty vb vc Empty) =
  Tr B Empty s t (Tr v Empty vb vc Empty);
balance Empty s t (Tr v (Tr B ve vf vga vha) vb vc Empty) =
  Tr B Empty s t (Tr v (Tr B ve vf vga vha) vb vc Empty);
balance Empty s t (Tr B va vb vc (Tr B vfa vg vh vi)) =
  Tr B Empty s t (Tr B va vb vc (Tr B vfa vg vh vi));
balance Empty s t (Tr v Empty vb vc (Tr B vfa vg vh vi)) =
  Tr B Empty s t (Tr v Empty vb vc (Tr B vfa vg vh vi));
balance Empty s t (Tr v (Tr B ve vj vka vla) vb vc (Tr B vfa vg vh vi)) =
  Tr B Empty s t (Tr v (Tr B ve vj vka vla) vb vc (Tr B vfa vg vh vi));
balance (Tr B va vb vc vd) s t Empty = Tr B (Tr B va vb vc vd) s t Empty;
balance (Tr B va vb vc vd) s t (Tr B ve vf vga vha) =
  Tr B (Tr B va vb vc vd) s t (Tr B ve vf vga vha);
balance (Tr B va vb vc vd) s t (Tr B ve vf vga Empty) =
  Tr B (Tr B va vb vc vd) s t (Tr B ve vf vga Empty);
balance (Tr B va vb vc vd) s t (Tr v Empty vf vga Empty) =
  Tr B (Tr B va vb vc vd) s t (Tr v Empty vf vga Empty);
balance (Tr B va vb vc vd) s t (Tr v (Tr B vi vj vka vla) vf vga Empty) =
  Tr B (Tr B va vb vc vd) s t (Tr v (Tr B vi vj vka vla) vf vga Empty);
balance (Tr B va vb vc vd) s t (Tr B ve vf vga (Tr B vja vk vl vm)) =
  Tr B (Tr B va vb vc vd) s t (Tr B ve vf vga (Tr B vja vk vl vm));
balance (Tr B va vb vc vd) s t (Tr v Empty vf vga (Tr B vja vk vl vm)) =
  Tr B (Tr B va vb vc vd) s t (Tr v Empty vf vga (Tr B vja vk vl vm));
balance (Tr B va vb vc vd) s t
  (Tr v (Tr B vi vn vo vp) vf vga (Tr B vja vk vl vm)) =
  Tr B (Tr B va vb vc vd) s t
    (Tr v (Tr B vi vn vo vp) vf vga (Tr B vja vk vl vm));
balance Empty s t Empty = Tr B Empty s t Empty;
balance (Tr B va vb vc vd) s t Empty = Tr B (Tr B va vb vc vd) s t Empty;
balance (Tr B Empty vb vc vd) s t Empty = Tr B (Tr B Empty vb vc vd) s t Empty;
balance (Tr v Empty vb vc Empty) s t Empty =
  Tr B (Tr v Empty vb vc Empty) s t Empty;
balance (Tr v Empty vb vc (Tr B ve vf vga vha)) s t Empty =
  Tr B (Tr v Empty vb vc (Tr B ve vf vga vha)) s t Empty;
balance (Tr B (Tr B vfa vg vh vi) vb vc vd) s t Empty =
  Tr B (Tr B (Tr B vfa vg vh vi) vb vc vd) s t Empty;
balance (Tr v (Tr B vfa vg vh vi) vb vc Empty) s t Empty =
  Tr B (Tr v (Tr B vfa vg vh vi) vb vc Empty) s t Empty;
balance (Tr v (Tr B vfa vg vh vi) vb vc (Tr B ve vj vka vla)) s t Empty =
  Tr B (Tr v (Tr B vfa vg vh vi) vb vc (Tr B ve vj vka vla)) s t Empty;
balance Empty s t (Tr B va vb vc vd) = Tr B Empty s t (Tr B va vb vc vd);
balance (Tr B ve vf vga vha) s t (Tr B va vb vc vd) =
  Tr B (Tr B ve vf vga vha) s t (Tr B va vb vc vd);
balance (Tr B Empty vf vga vha) s t (Tr B va vb vc vd) =
  Tr B (Tr B Empty vf vga vha) s t (Tr B va vb vc vd);
balance (Tr v Empty vf vga Empty) s t (Tr B va vb vc vd) =
  Tr B (Tr v Empty vf vga Empty) s t (Tr B va vb vc vd);
balance (Tr v Empty vf vga (Tr B vi vj vka vla)) s t (Tr B va vb vc vd) =
  Tr B (Tr v Empty vf vga (Tr B vi vj vka vla)) s t (Tr B va vb vc vd);
balance (Tr B (Tr B vja vk vl vm) vf vga vha) s t (Tr B va vb vc vd) =
  Tr B (Tr B (Tr B vja vk vl vm) vf vga vha) s t (Tr B va vb vc vd);
balance (Tr v (Tr B vja vk vl vm) vf vga Empty) s t (Tr B va vb vc vd) =
  Tr B (Tr v (Tr B vja vk vl vm) vf vga Empty) s t (Tr B va vb vc vd);
balance (Tr v (Tr B vja vk vl vm) vf vga (Tr B vi vn vo vp)) s t
  (Tr B va vb vc vd) =
  Tr B (Tr v (Tr B vja vk vl vm) vf vga (Tr B vi vn vo vp)) s t
    (Tr B va vb vc vd);

class (Orda a) => Preorder a where {
};

class (Preorder a) => Order a where {
};

class (Order a) => Linorder a where {
};

ins ::
  forall a b.
    (Linorder a) => (a -> b -> b -> b) -> a -> b -> Rbt a b -> Rbt a b;
ins f k v Empty = Tr R Empty k v Empty;
ins f k v (Tr B l x y r) =
  (if less k x then balance (ins f k v l) x y r
    else (if less x k then balance l x y (ins f k v r)
           else Tr B l x (f k y v) r));
ins f k v (Tr R l x y r) =
  (if less k x then Tr R (ins f k v l) x y r
    else (if less x k then Tr R l x y (ins f k v r) else Tr R l x (f k y v) r));

rhsl :: forall a b. Ta_rule a b -> b;
rhsl (Rule q l qs) = l;

rhsq :: forall a b. Ta_rule a b -> [a];
rhsq (Rule q l qs) = qs;

data Ustate_wrapper a b = USW1 a | USW2 b deriving (Read, Show);

mapa :: forall b a. (b -> a) -> [b] -> [a];
mapa f [] = [];
mapa f (x : xs) = f x : mapa f xs;

foldla :: forall a b. (a -> b -> a) -> a -> [b] -> a;
foldla f a [] = a;
foldla f a (x : xs) = foldla f (f a x) xs;

rev :: forall a. [a] -> [a];
rev xs = foldla (\ xsa x -> x : xsa) [] xs;

list_case :: forall t a. t -> (a -> [a] -> t) -> [a] -> t;
list_case f1 f2 (a : list) = f2 a list;
list_case f1 f2 [] = f1;

zipa :: forall a b. [a] -> [b] -> [(a, b)];
zipa xs [] = [];
zipa xs (y : ys) = (case xs of {
                     [] -> [];
                     z : zs -> (z, y) : zipa zs ys;
                   });

data Tree a = Node a [(Tree a)] deriving (Read, Show);

nulla :: forall a. [a] -> Bool;
nulla [] = True;
nulla (x : xs) = False;

revg :: forall a. [a] -> [a] -> [a];
revg [] b = b;
revg (a : asa) b = revg asa (a : b);

paint :: forall a b. Color -> Rbt a b -> Rbt a b;
paint c Empty = Empty;
paint c (Tr uu l k v r) = Tr c l k v r;

insertwithkey ::
  forall a b.
    (Linorder a) => (a -> b -> b -> b) -> a -> b -> Rbt a b -> Rbt a b;
insertwithkey f k v t = paint B (ins f k v t);

insrt :: forall a b. (Linorder a) => a -> b -> Rbt a b -> Rbt a b;
insrt k v t = insertwithkey (\ uu uua nv -> nv) k v t;

r_prod :: forall a b c d. Ta_rule a b -> Ta_rule c d -> Ta_rule (a, c) b;
r_prod (Rule q1 l1 qs1) (Rule q2 l2 qs2) = Rule (q1, q2) l1 (zipa qs1 qs2);

instance Orda Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

map_ofa :: forall b c. (Eq b) => [(b, c)] -> b -> Maybe c;
map_ofa ((l, v) : ps) k = (if l == k then Just v else map_ofa ps k);
map_ofa [] k = Nothing;

the :: forall a. Maybe a -> a;
the (Just x) = x;

map_of :: forall a b. (Linorder a) => Rbt a b -> a -> Maybe b;
map_of Empty k = Nothing;
map_of (Tr uu l x y r) k =
  (if less k x then map_of l k else (if less x k then map_of r k else Just y));

inj_image_filter_cp ::
  forall x sb sa y s z.
    ((x -> sb -> sb) -> sa -> sb -> sb) ->
      ((y -> sb -> sb) -> s -> sb -> sb) ->
        sb -> (z -> sb -> sb) ->
                (x -> y -> z) -> (x -> y -> Bool) -> sa -> s -> sb;
inj_image_filter_cp iterate1 iterate2 empty3 insert_dj3 f p s1 s2 =
  iterate1
    (\ x ->
      iterate2 (\ y res -> (if p x y then insert_dj3 (f x y) res else res)) s2)
    s1
    empty3;

cart ::
  forall b a c d e.
    ((b -> a -> a) -> c -> a -> a) ->
      ((d -> a -> a) -> e -> a -> a) -> a -> ((b, d) -> a -> a) -> c -> e -> a;
cart it1 it2 empty3 ins3 s1 s2 =
  inj_image_filter_cp it1 it2 empty3 ins3 (\ a b -> (a, b)) (\ x y -> True) s1
    s2;

member :: forall a. (Eq a) => a -> [a] -> Bool;
member x [] = False;
member x (y : ys) = x == y || member x ys;

instance Preorder Integer where {
};

instance Order Integer where {
};

remdups :: forall a. (Eq a) => [a] -> [a];
remdups [] = [];
remdups (x : xs) = (if member x xs then remdups xs else x : remdups xs);

it_add ::
  forall u v s.
    (u -> v -> s -> s) -> ((u -> v -> s -> s) -> s -> s -> s) -> s -> s -> s;
it_add update iteratea m1 m2 = iteratea update m2 m1;

eq_ta_rule :: forall q l. (Eq q, Eq l) => Ta_rule q l -> Ta_rule q l -> Bool;
eq_ta_rule (Rule q l list) (Rule q' l' list') =
  q == q' && (l == l' && list == list');

instance (Eq a, Eq b) => Eq (Ta_rule a b) where {
  a == b = eq_ta_rule a b;
};

fifo_get :: forall a. ([a], [a]) -> (a, ([a], [a]));
fifo_get f =
  (case snd f of {
    [] -> let {
            rp = rev (fst f);
          } in (hd rp, ([], tl rp));
    a : l -> (a, (fst f, l));
  });

fifo_put :: forall a. a -> ([a], [a]) -> ([a], [a]);
fifo_put a f = (a : fst f, snd f);

list_all :: forall a. (a -> Bool) -> [a] -> Bool;
list_all p [] = True;
list_all p (x : xs) = p x && list_all p xs;

is_none :: forall b. Maybe b -> Bool;
is_none (Just x) = False;
is_none Nothing = True;

iti_sel ::
  forall a k v b r s c.
    ((Maybe a -> Bool) -> (k -> v -> b -> Maybe r) -> s -> Maybe c -> Maybe r)
      -> s -> (k -> v -> Maybe r) -> Maybe r;
iti_sel iti m f = iti is_none (\ k v res -> f k v) m Nothing;

map_sng :: forall m k v. m -> (k -> v -> m -> m) -> k -> v -> m;
map_sng empt update k v = update k v empt;

minus_nat :: Nat.Nat -> Nat.Nat -> Nat.Nat;
minus_nat n m = fromInteger (toInteger n - toInteger m);

it_size ::
  forall x s.
    ((x -> Nat.Nat -> Nat.Nat) -> s -> Nat.Nat -> Nat.Nat) -> s -> Nat.Nat;
it_size iteratea s = iteratea (\ x -> suc) s 0;

remap_rule :: forall a b c. (a -> b) -> Ta_rule a c -> Ta_rule b c;
remap_rule f (Rule q l qs) = Rule (f q) l (mapa f qs);

instance Linorder Integer where {
};

lm_iterate_code :: forall a b c. (a -> b -> c -> c) -> [(a, b)] -> c -> c;
lm_iterate_code f [] sigma = sigma;
lm_iterate_code f ((k, v) : l) sigma = lm_iterate_code f l (f k v sigma);

lm_iterate :: forall a b c. (a -> b -> c -> c) -> [(a, b)] -> c -> c;
lm_iterate a = lm_iterate_code a;

foldwithkey ::
  forall a b c. (Linorder a) => (a -> b -> c -> c) -> Rbt a b -> c -> c;
foldwithkey f Empty v = v;
foldwithkey f (Tr c lt k x rt) v =
  foldwithkey f rt (f k x (foldwithkey f lt v));

rm_iterate ::
  forall k v sigma.
    (Linorder k) => (k -> v -> sigma -> sigma) -> Rbt k v -> sigma -> sigma;
rm_iterate f t sigma_0 = foldwithkey f t sigma_0;

hm_iterate ::
  forall b c a d.
    (Linorder d) => (b -> c -> a -> a) -> Rbt d [(b, c)] -> a -> a;
hm_iterate f m sigma_0 = rm_iterate (\ hc -> lm_iterate f) m sigma_0;

update ::
  forall key val. (Eq key) => key -> val -> [(key, val)] -> [(key, val)];
update k v [] = [(k, v)];
update k v (p : ps) = (if fst p == k then (k, v) : ps else p : update k v ps);

lm_update :: forall a b. (Eq a) => a -> b -> [(a, b)] -> [(a, b)];
lm_update a = update a;

lm_empty :: forall a. [a];
lm_empty = [];

lm_sng :: forall a b. (Eq a) => a -> b -> [(a, b)];
lm_sng a = map_sng lm_empty lm_update a;

rm_update :: forall a b. (Linorder a) => a -> b -> Rbt a b -> Rbt a b;
rm_update a = insrt a;

rm_lookup :: forall b a. (Linorder b) => b -> Rbt b a -> Maybe a;
rm_lookup k m = map_of m k;

option_case :: forall t a. t -> (a -> t) -> Maybe a -> t;
option_case f1 f2 (Just a) = f2 a;
option_case f1 f2 Nothing = f1;

class Hashable a where {
  hashcode :: a -> Integer;
};

hm_update ::
  forall k v.
    (Eq k,
      Hashable k) => k -> v -> Rbt Integer [(k, v)] -> Rbt Integer [(k, v)];
hm_update k v m =
  let {
    hc = hashcode k;
  } in (case rm_lookup hc m of {
         Nothing -> rm_update hc (lm_sng k v) m;
         Just bm -> rm_update hc (lm_update k v bm) m;
       });

hm_add ::
  forall a b.
    (Eq a,
      Hashable a) => Rbt Integer [(a, b)] ->
                       Rbt Integer [(a, b)] -> Rbt Integer [(a, b)];
hm_add a = it_add hm_update hm_iterate a;

lm_iteratei ::
  forall a b c. (a -> Bool) -> (b -> c -> a -> a) -> [(b, c)] -> a -> a;
lm_iteratei c f [] sigma = sigma;
lm_iteratei c f ((k, v) : l) sigma =
  (if c sigma then lm_iteratei c f l (f k v sigma) else sigma);

lm_sel :: forall a b c. [(a, b)] -> (a -> b -> Maybe c) -> Maybe c;
lm_sel a = iti_sel lm_iteratei a;

rm_iteratei ::
  forall a b c. (a -> Bool) -> (b -> c -> a -> a) -> Rbt b c -> a -> a;
rm_iteratei c f Empty sigma = sigma;
rm_iteratei c f (Tr col l k v r) sigma =
  (if c sigma then rm_iteratei c f l (rm_iteratei c f r (f k v sigma))
    else sigma);

rm_sel :: forall a b c. Rbt a b -> (a -> b -> Maybe c) -> Maybe c;
rm_sel a = iti_sel rm_iteratei a;

hm_sel ::
  forall k v r.
    (Hashable k) => Rbt Integer [(k, v)] -> (k -> v -> Maybe r) -> Maybe r;
hm_sel m f = rm_sel m (\ hc lm -> lm_sel lm f);

s_ins :: forall b c a. (b -> () -> c -> a) -> b -> c -> a;
s_ins update x s = update x () s;

hs_ins ::
  forall a.
    (Eq a, Hashable a) => a -> Rbt Integer [(a, ())] -> Rbt Integer [(a, ())];
hs_ins a = s_ins hm_update a;

s_sel ::
  forall s u r.
    (s -> (u -> () -> Maybe r) -> Maybe r) -> s -> (u -> Maybe r) -> Maybe r;
s_sel sel s f = sel s (\ u v -> f u);

hs_sel ::
  forall a r.
    (Hashable a) => Rbt Integer [(a, ())] -> (a -> Maybe r) -> Maybe r;
hs_sel a = s_sel hm_sel a;

size_list :: forall a. [a] -> Nat.Nat;
size_list [] = 0;
size_list (a : list) = size_list list + suc 0;

it_inter ::
  forall x sb sa s.
    ((x -> sb -> sb) -> sa -> sb -> sb) ->
      (x -> s -> Bool) -> sb -> (x -> sb -> sb) -> sa -> s -> sb;
it_inter iterate1 memb2 empt3 insrt3 s1 s2 =
  iterate1 (\ x s -> (if memb2 x s2 then insrt3 x s else s)) s1 empt3;

it_union ::
  forall x sa s.
    ((x -> sa -> sa) -> s -> sa -> sa) -> (x -> sa -> sa) -> s -> sa -> sa;
it_union iterate1 insrt2 s1 s2 = iterate1 insrt2 s1 s2;

rm_empty :: forall a b. Rbt a b;
rm_empty = Empty;

hm_empty :: forall a b. Rbt a b;
hm_empty = rm_empty;

s_empty :: forall a. a -> a;
s_empty empt = empt;

hs_empty :: forall a. (Hashable a) => Rbt Integer [(a, ())];
hs_empty = s_empty hm_empty;

ls_iteratei :: forall a b. (a -> Bool) -> (b -> a -> a) -> [b] -> a -> a;
ls_iteratei c f [] sigma = sigma;
ls_iteratei c f (x : l) sigma =
  (if c sigma then ls_iteratei c f l (f x sigma) else sigma);

iti_iterate ::
  forall sigma a s.
    ((sigma -> Bool) -> (a -> sigma -> sigma) -> s -> sigma -> sigma) ->
      (a -> sigma -> sigma) -> s -> sigma -> sigma;
iti_iterate iti = iti (\ x -> True);

ls_iterate :: forall a sigma. (a -> sigma -> sigma) -> [a] -> sigma -> sigma;
ls_iterate a = iti_iterate ls_iteratei a;

it_image_filter ::
  forall a sa s b.
    ((a -> sa -> sa) -> s -> sa -> sa) ->
      sa -> (b -> sa -> sa) -> (a -> Maybe b) -> s -> sa;
it_image_filter iterate1 empty2 ins2 f s =
  iterate1
    (\ x res -> (case f x of {
                  Nothing -> res;
                  Just v -> ins2 v res;
                }))
    s
    empty2;

lh_image_filter ::
  forall a b.
    (Eq b, Hashable b) => (a -> Maybe b) -> [a] -> Rbt Integer [(b, ())];
lh_image_filter a = it_image_filter ls_iterate hs_empty hs_ins a;

brc_iq ::
  forall q l. (Eq q, Hashable q) => [(Ta_rule q l)] -> Rbt Integer [(q, ())];
brc_iq delta =
  lh_image_filter (\ r -> (if nulla (rhsq r) then Just (lhs r) else Nothing))
    delta;

newtype HashedTa_ext_type a b c = Abs_hashedTa_ext_type
  (Rbt Integer [(a, ())],
    ([(Ta_rule a b)],
      (Maybe (Rbt Integer [(b, [(Ta_rule a b)])]),
        (Maybe (Rbt Integer [(a, [(Ta_rule a b)])]),
          (Maybe (Rbt Integer [((a, b), [(Ta_rule a b)])]), c)))))
  deriving (Read, Show);

rep_hashedTa_ext_type ::
  forall q l z.
    HashedTa_ext_type q l z ->
      (Rbt Integer [(q, ())],
        ([(Ta_rule q l)],
          (Maybe (Rbt Integer [(l, [(Ta_rule q l)])]),
            (Maybe (Rbt Integer [(q, [(Ta_rule q l)])]),
              (Maybe (Rbt Integer [((q, l), [(Ta_rule q l)])]), z)))));
rep_hashedTa_ext_type (Abs_hashedTa_ext_type y) = y;

hta_idx_f_sel ::
  forall q l z.
    HashedTa_ext_type q l z -> Maybe (Rbt Integer [(l, [(Ta_rule q l)])]);
hta_idx_f_sel r = fst (snd (snd (rep_hashedTa_ext_type r)));

hta_idx_f ::
  forall q l z.
    HashedTa_ext_type q l z -> Maybe (Rbt Integer [(l, [(Ta_rule q l)])]);
hta_idx_f a = hta_idx_f_sel a;

ls_empty :: forall a. [a];
ls_empty = [];

lm_lookup :: forall b a. (Eq b) => b -> [(b, a)] -> Maybe a;
lm_lookup k m = map_ofa m k;

hm_lookup ::
  forall k v. (Eq k, Hashable k) => k -> Rbt Integer [(k, v)] -> Maybe v;
hm_lookup k m =
  (case rm_lookup (hashcode k) m of {
    Nothing -> Nothing;
    Just a -> lm_lookup k a;
  });

idx_lookup :: forall i m t. (i -> m -> Maybe t) -> t -> i -> m -> t;
idx_lookup mlookup tempty i m =
  (case mlookup i m of {
    Nothing -> tempty;
    Just s -> s;
  });

hl_idx_lookup ::
  forall a b. (Eq a, Hashable a) => a -> Rbt Integer [(a, [b])] -> [b];
hl_idx_lookup a = idx_lookup hm_lookup ls_empty a;

hta_lookup_f ::
  forall b a c.
    (Eq b, Hashable b) => b -> HashedTa_ext_type a b c -> [(Ta_rule a b)];
hta_lookup_f f h = hl_idx_lookup f (the (hta_idx_f h));

ls_memb :: forall a. (Eq a) => a -> [a] -> Bool;
ls_memb a = member a;

list_all_zip :: forall a b. (a -> b -> Bool) -> [a] -> [b] -> Bool;
list_all_zip p [] [] = True;
list_all_zip p (a : asa) (b : bs) = p a b && list_all_zip p asa bs;
list_all_zip p (v : vaa) [] = False;
list_all_zip p [] (va : vab) = False;

ta_rule_case :: forall q l t. (q -> l -> [q] -> t) -> Ta_rule q l -> t;
ta_rule_case f1 (Rule q l list) = f1 q l list;

ls_ins :: forall a. (Eq a) => a -> [a] -> [a];
ls_ins x l = (if member x l then l else x : l);

ls_image_filter :: forall a b. (Eq b) => (a -> Maybe b) -> [a] -> [b];
ls_image_filter a = it_image_filter ls_iterate ls_empty ls_ins a;

faccs' ::
  forall a b c.
    (Eq a, Eq b, Hashable b) => HashedTa_ext_type a b c -> Tree b -> [a];
faccs' h (Node f ts) =
  let {
    qs = mapa (faccs' h) ts;
  } in ls_image_filter
         (\ (r @ (Rule q f' qsa)) ->
           (if list_all_zip (\ qa qaa -> ls_memb qaa qa) qs qsa
             then Just (lhs r) else Nothing))
         (hta_lookup_f f h);

hta_Qi_sel :: forall q l z. HashedTa_ext_type q l z -> Rbt Integer [(q, ())];
hta_Qi_sel r = fst (rep_hashedTa_ext_type r);

hta_Qi :: forall q l z. HashedTa_ext_type q l z -> Rbt Integer [(q, ())];
hta_Qi a = hta_Qi_sel a;

fifo_empty :: forall a. ([a], [a]);
fifo_empty = ([], []);

s_memb :: forall a b c. (a -> b -> Maybe c) -> a -> b -> Bool;
s_memb lookupa x s = not (is_none (lookupa x s));

hs_memb :: forall a. (Eq a, Hashable a) => a -> Rbt Integer [(a, ())] -> Bool;
hs_memb a = s_memb hm_lookup a;

s_iterate ::
  forall b c d e f g a.
    ((b -> c -> d -> e) -> f -> g -> a) -> (b -> d -> e) -> f -> g -> a;
s_iterate iteratea f s sigma_0 = iteratea (\ k v -> f k) s sigma_0;

hs_iterate ::
  forall a sigma.
    (Hashable a) => (a -> sigma -> sigma) ->
                      Rbt Integer [(a, ())] -> sigma -> sigma;
hs_iterate a = s_iterate hm_iterate a;

hs_size :: forall a. (Hashable a) => Rbt Integer [(a, ())] -> Nat.Nat;
hs_size a = it_size hs_iterate a;

idx_build_stepfun ::
  forall i m t x.
    (i -> m -> Maybe t) ->
      (i -> t -> m -> m) -> t -> (x -> t -> t) -> (x -> i) -> x -> m -> m;
idx_build_stepfun mlookup mupdate tempty tinsert f x m =
  let {
    i = f x;
  } in (case mlookup i m of {
         Nothing -> mupdate i (tinsert x tempty) m;
         Just s -> mupdate i (tinsert x s) m;
       });

idx_build ::
  forall m i t x s.
    m -> (i -> m -> Maybe t) ->
           (i -> t -> m -> m) ->
             t -> (x -> t -> t) ->
                    ((x -> m -> m) -> s -> m -> m) -> (x -> i) -> s -> m;
idx_build mempty mlookup mupdate tempty tinsert siterate f s =
  siterate (idx_build_stepfun mlookup mupdate tempty tinsert f) s mempty;

hta_delta_sel :: forall q l z. HashedTa_ext_type q l z -> [(Ta_rule q l)];
hta_delta_sel r = fst (snd (rep_hashedTa_ext_type r));

hta_delta :: forall q l z. HashedTa_ext_type q l z -> [(Ta_rule q l)];
hta_delta a = hta_delta_sel a;

hll_idx_build ::
  forall a b.
    (Eq a, Eq b, Hashable b) => (a -> b) -> [a] -> Rbt Integer [(b, [a])];
hll_idx_build a =
  idx_build hm_empty hm_lookup hm_update ls_empty ls_ins ls_iterate a;

build_rule_index ::
  forall q l i.
    (Eq q, Eq l, Eq i,
      Hashable i) => (Ta_rule q l -> i) ->
                       [(Ta_rule q l)] -> Rbt Integer [(i, [(Ta_rule q l)])];
build_rule_index a = hll_idx_build a;

build_rule_index_f ::
  forall b a.
    (Eq b, Eq a,
      Hashable a) => [(Ta_rule b a)] -> Rbt Integer [(a, [(Ta_rule b a)])];
build_rule_index_f delta = build_rule_index rhsl delta;

more_sel :: forall q l z. HashedTa_ext_type q l z -> z;
more_sel r = snd (snd (snd (snd (snd (rep_hashedTa_ext_type r)))));

hta_idx_sf_sel ::
  forall q l z.
    HashedTa_ext_type q l z -> Maybe (Rbt Integer [((q, l), [(Ta_rule q l)])]);
hta_idx_sf_sel r = fst (snd (snd (snd (snd (rep_hashedTa_ext_type r)))));

hta_idx_s_sel ::
  forall q l z.
    HashedTa_ext_type q l z -> Maybe (Rbt Integer [(q, [(Ta_rule q l)])]);
hta_idx_s_sel r = fst (snd (snd (snd (rep_hashedTa_ext_type r))));

hashedTa_ext ::
  forall q l z.
    Rbt Integer [(q, ())] ->
      [(Ta_rule q l)] ->
        Maybe (Rbt Integer [(l, [(Ta_rule q l)])]) ->
          Maybe (Rbt Integer [(q, [(Ta_rule q l)])]) ->
            Maybe (Rbt Integer [((q, l), [(Ta_rule q l)])]) ->
              z -> HashedTa_ext_type q l z;
hashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more =
  Abs_hashedTa_ext_type
    (hta_Qi, (hta_delta, (hta_idx_f, (hta_idx_s, (hta_idx_sf, more)))));

hta_idx_f_upd ::
  forall l q z.
    (Maybe (Rbt Integer [(l, [(Ta_rule q l)])]) ->
      Maybe (Rbt Integer [(l, [(Ta_rule q l)])]))
      -> HashedTa_ext_type q l z -> HashedTa_ext_type q l z;
hta_idx_f_upd hta_idx_f r =
  hashedTa_ext (hta_Qi_sel r) (hta_delta_sel r) (hta_idx_f (hta_idx_f_sel r))
    (hta_idx_s_sel r) (hta_idx_sf_sel r) (more_sel r);

hta_idx_f_update ::
  forall l q z.
    (Maybe (Rbt Integer [(l, [(Ta_rule q l)])]) ->
      Maybe (Rbt Integer [(l, [(Ta_rule q l)])]))
      -> HashedTa_ext_type q l z -> HashedTa_ext_type q l z;
hta_idx_f_update hta_idx_f r = hta_idx_f_upd hta_idx_f r;

hta_ensure_idx_f ::
  forall a b c.
    (Eq a, Eq b,
      Hashable b) => HashedTa_ext_type a b c -> HashedTa_ext_type a b c;
hta_ensure_idx_f h =
  (case hta_idx_f h of {
    Nothing ->
      hta_idx_f_update (\ x -> Just (build_rule_index_f (hta_delta h))) h;
    Just x -> h;
  });

ls_ball :: forall a. [a] -> (a -> Bool) -> Bool;
ls_ball l p = list_all p l;

ball_disjoint ::
  forall b c a d. (b -> (c -> Bool) -> a) -> (c -> d -> Bool) -> b -> d -> a;
ball_disjoint ball1 memb2 s1 s2 = ball1 s1 (\ x -> not (memb2 x s2));

lh_disjoint ::
  forall a. (Eq a, Hashable a) => [a] -> Rbt Integer [(a, ())] -> Bool;
lh_disjoint a = ball_disjoint ls_ball hs_memb a;

hta_mem' ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Tree a -> HashedTa_ext_type b a c -> Bool;
hta_mem' t h = not (lh_disjoint (faccs' h t) (hta_Qi h));

hta_mem ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Tree a -> HashedTa_ext_type b a c -> Bool;
hta_mem t h = hta_mem' t (hta_ensure_idx_f h);

split :: forall b c a. (b -> c -> a) -> (b, c) -> a;
split f (a, b) = f a b;

pa_cond ::
  forall qa q l.
    (Hashable qa, Hashable q,
      Hashable l) => (Rbt Integer [((qa, q), ())],
                       ([(qa, q)], [(Ta_rule (qa, q) l)]))
                       -> Bool;
pa_cond s = let {
              a = s;
              (q, aa) = a;
              (w, delta_d) = aa;
            } in not (nulla w);

hta_idx_s ::
  forall q l z.
    HashedTa_ext_type q l z -> Maybe (Rbt Integer [(q, [(Ta_rule q l)])]);
hta_idx_s a = hta_idx_s_sel a;

hta_lookup_s ::
  forall a b c.
    (Eq a, Hashable a) => a -> HashedTa_ext_type a b c -> [(Ta_rule a b)];
hta_lookup_s q h = hl_idx_lookup q (the (hta_idx_s h));

hta_idx_sf ::
  forall q l z.
    HashedTa_ext_type q l z -> Maybe (Rbt Integer [((q, l), [(Ta_rule q l)])]);
hta_idx_sf a = hta_idx_sf_sel a;

prod_case :: forall a b t. (a -> b -> t) -> (a, b) -> t;
prod_case f1 (a, b) = f1 a b;

hashcodea :: forall a b. (Hashable a, Hashable b) => (a, b) -> Integer;
hashcodea x = let {
                (a, b) = x;
              } in hashcode a + hashcode b;

instance (Hashable a, Hashable b) => Hashable (a, b) where {
  hashcode = hashcodea;
};

hta_lookup_sf ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => a -> b -> HashedTa_ext_type a b c -> [(Ta_rule a b)];
hta_lookup_sf q f h = hl_idx_lookup (q, f) (the (hta_idx_sf h));

ls_ins_dj :: forall a. a -> [a] -> [a];
ls_ins_dj x l = x : l;

pa_upd_rule ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Rbt Integer [((a, b), ())] ->
                       [(a, b)] ->
                         [(a, b)] -> (Rbt Integer [((a, b), ())], [(a, b)]);
pa_upd_rule q w [] = (q, w);
pa_upd_rule q w (qp : qs) =
  (if not (hs_memb qp q) then pa_upd_rule (hs_ins qp q) (qp : w) qs
    else pa_upd_rule q w qs);

pa_step ::
  forall qa l q.
    (Eq qa, Hashable qa, Eq l, Hashable l, Eq q,
      Hashable q) => HashedTa_ext_type qa l () ->
                       HashedTa_ext_type q l () ->
                         (Rbt Integer [((qa, q), ())],
                           ([(qa, q)], [(Ta_rule (qa, q) l)]))
                           -> (Rbt Integer [((qa, q), ())],
                                ([(qa, q)], [(Ta_rule (qa, q) l)]));
pa_step h1 h2 s =
  let {
    a = s;
    (q, aa) = a;
    (w, delta_d) = aa;
    ab = hd w;
    (q1, q2) = ab;
  } in ls_iterate
         (\ r1 ->
           ls_iterate
             (\ r2 res ->
               (if size_list (rhsq r1) == size_list (rhsq r2)
                 then let {
                        rp = r_prod r1 r2;
                        ac = res;
                        (qa, ad) = ac;
                        (wa, delta_da) = ad;
                        ae = pa_upd_rule qa wa (rhsq rp);
                        (q', w') = ae;
                      } in (q', (w', ls_ins_dj rp delta_da))
                 else res))
             (hta_lookup_sf q2 (rhsl r1) h2))
         (hta_lookup_s q1 h1) (q, (tl w, delta_d));

map_to_nat ::
  forall x m s.
    ((x -> (Nat.Nat, m) -> (Nat.Nat, m)) -> s -> (Nat.Nat, m) -> (Nat.Nat, m))
      -> m -> (x -> Nat.Nat -> m -> m) -> s -> m;
map_to_nat iterate1 empty2 update2 s =
  snd (iterate1 (\ x (a @ (c, m)) -> (c + 1, update2 x c m)) s (0, empty2));

hs_image_filter ::
  forall a b.
    (Hashable a, Eq b,
      Hashable b) => (a -> Maybe b) ->
                       Rbt Integer [(a, ())] -> Rbt Integer [(b, ())];
hs_image_filter a = it_image_filter hs_iterate hs_empty hs_ins a;

iflt_image :: forall b c d a. ((b -> Maybe c) -> d -> a) -> (b -> c) -> d -> a;
iflt_image iflt f s = iflt (\ x -> Just (f x)) s;

hs_image ::
  forall a b.
    (Hashable a, Eq b,
      Hashable b) => (a -> b) -> Rbt Integer [(a, ())] -> Rbt Integer [(b, ())];
hs_image a = iflt_image hs_image_filter a;

hm_update_dj ::
  forall a b.
    (Eq a,
      Hashable a) => a -> b -> Rbt Integer [(a, b)] -> Rbt Integer [(a, b)];
hm_update_dj a = hm_update a;

s_ins_dj :: forall b c a. (b -> () -> c -> a) -> b -> c -> a;
s_ins_dj update_dj x s = update_dj x () s;

hs_ins_dj ::
  forall a.
    (Eq a, Hashable a) => a -> Rbt Integer [(a, ())] -> Rbt Integer [(a, ())];
hs_ins_dj a = s_ins_dj hm_update_dj a;

hs_inter ::
  forall a.
    (Eq a,
      Hashable a) => Rbt Integer [(a, ())] ->
                       Rbt Integer [(a, ())] -> Rbt Integer [(a, ())];
hs_inter a = it_inter hs_iterate hs_memb hs_empty hs_ins_dj a;

s_union :: forall a. a -> a;
s_union add = add;

hs_union ::
  forall a.
    (Eq a,
      Hashable a) => Rbt Integer [(a, ())] ->
                       Rbt Integer [(a, ())] -> Rbt Integer [(a, ())];
hs_union a = s_union hm_add a;

hhh_cart ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Rbt Integer [(a, ())] ->
                       Rbt Integer [(b, ())] -> Rbt Integer [((a, b), ())];
hhh_cart a = cart hs_iterate hs_iterate hs_empty hs_ins_dj a;

brc_cond ::
  forall q l.
    (Hashable q,
      Hashable l) => (Rbt Integer [(q, ())],
                       ([q], Rbt Integer [(Ta_rule q l, Nat.Nat)]))
                       -> Bool;
brc_cond a = let {
               (q, aa) = a;
               (w, rcm) = aa;
             } in not (nulla w);

rqrm_lookup ::
  forall b a. (Eq b, Hashable b) => Rbt Integer [(b, [a])] -> b -> [a];
rqrm_lookup rqrm q =
  (case hm_lookup q rqrm of {
    Nothing -> ls_empty;
    Just s -> s;
  });

hashcode_of_list :: forall a. (Hashable a) => [a] -> Integer;
hashcode_of_list [] = 0;
hashcode_of_list (x : xs) = hashcode x + hashcode_of_list xs;

hashcode_list :: forall a. (Hashable a) => [a] -> Integer;
hashcode_list a = hashcode_of_list a;

hashcode_of_ta_rule ::
  forall c d. (Hashable c, Hashable d) => Ta_rule c d -> Integer;
hashcode_of_ta_rule (Rule q f qs) = hashcode q + hashcode f + hashcode_list qs;

hashcode_ta_rule ::
  forall a b. (Hashable a, Hashable b) => Ta_rule a b -> Integer;
hashcode_ta_rule a = hashcode_of_ta_rule a;

instance (Hashable a, Hashable b) => Hashable (Ta_rule a b) where {
  hashcode = hashcode_ta_rule;
};

brc_inner_step ::
  forall q l.
    (Eq q, Hashable q, Eq l,
      Hashable l) => Ta_rule q l ->
                       (Rbt Integer [(q, ())],
                         ([q], Rbt Integer [(Ta_rule q l, Nat.Nat)]))
                         -> (Rbt Integer [(q, ())],
                              ([q], Rbt Integer [(Ta_rule q l, Nat.Nat)]));
brc_inner_step r =
  (\ (a @ (q, aa)) ->
    let {
      (w, rcm) = aa;
      c = the (hm_lookup r rcm);
      rcm' = hm_update r (minus_nat c 1) rcm;
      q' = (if c <= 1 then hs_ins (lhs r) q else q);
      w' = (if c <= 1 && not (hs_memb (lhs r) q) then lhs r : w else w);
    } in (q', (w', rcm')));

brc_step ::
  forall q l.
    (Eq q, Hashable q, Eq l,
      Hashable l) => Rbt Integer [(q, [(Ta_rule q l)])] ->
                       (Rbt Integer [(q, ())],
                         ([q], Rbt Integer [(Ta_rule q l, Nat.Nat)]))
                         -> (Rbt Integer [(q, ())],
                              ([q], Rbt Integer [(Ta_rule q l, Nat.Nat)]));
brc_step rqrm =
  (\ (a @ (q, aa)) ->
    let {
      (w, rcm) = aa;
    } in ls_iterate brc_inner_step (rqrm_lookup rqrm (hd w)) (q, (tl w, rcm)));

brec_iqm ::
  forall q l.
    (Eq q, Hashable q,
      Hashable l) => [(Ta_rule q l)] -> Rbt Integer [(q, Tree l)];
brec_iqm delta =
  ls_iterate
    (\ r m ->
      (if nulla (rhsq r) then hm_update (lhs r) (Node (rhsl r) []) m else m))
    delta hm_empty;

build_rule_index_sf ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => [(Ta_rule a b)] -> Rbt Integer [((a, b), [(Ta_rule a b)])];
build_rule_index_sf delta = build_rule_index (\ r -> (lhs r, rhsl r)) delta;

hta_idx_sf_upd ::
  forall q l z.
    (Maybe (Rbt Integer [((q, l), [(Ta_rule q l)])]) ->
      Maybe (Rbt Integer [((q, l), [(Ta_rule q l)])]))
      -> HashedTa_ext_type q l z -> HashedTa_ext_type q l z;
hta_idx_sf_upd hta_idx_sf r =
  hashedTa_ext (hta_Qi_sel r) (hta_delta_sel r) (hta_idx_f_sel r)
    (hta_idx_s_sel r) (hta_idx_sf (hta_idx_sf_sel r)) (more_sel r);

hta_idx_sf_update ::
  forall q l z.
    (Maybe (Rbt Integer [((q, l), [(Ta_rule q l)])]) ->
      Maybe (Rbt Integer [((q, l), [(Ta_rule q l)])]))
      -> HashedTa_ext_type q l z -> HashedTa_ext_type q l z;
hta_idx_sf_update hta_idx_sf r = hta_idx_sf_upd hta_idx_sf r;

hta_ensure_idx_sf ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext_type a b c -> HashedTa_ext_type a b c;
hta_ensure_idx_sf h =
  (case hta_idx_sf h of {
    Nothing ->
      hta_idx_sf_update (\ x -> Just (build_rule_index_sf (hta_delta h))) h;
    Just x -> h;
  });

build_rule_index_s ::
  forall a b.
    (Eq a, Hashable a,
      Eq b) => [(Ta_rule a b)] -> Rbt Integer [(a, [(Ta_rule a b)])];
build_rule_index_s delta = build_rule_index lhs delta;

hta_idx_s_upd ::
  forall q l z.
    (Maybe (Rbt Integer [(q, [(Ta_rule q l)])]) ->
      Maybe (Rbt Integer [(q, [(Ta_rule q l)])]))
      -> HashedTa_ext_type q l z -> HashedTa_ext_type q l z;
hta_idx_s_upd hta_idx_s r =
  hashedTa_ext (hta_Qi_sel r) (hta_delta_sel r) (hta_idx_f_sel r)
    (hta_idx_s (hta_idx_s_sel r)) (hta_idx_sf_sel r) (more_sel r);

hta_idx_s_update ::
  forall q l z.
    (Maybe (Rbt Integer [(q, [(Ta_rule q l)])]) ->
      Maybe (Rbt Integer [(q, [(Ta_rule q l)])]))
      -> HashedTa_ext_type q l z -> HashedTa_ext_type q l z;
hta_idx_s_update hta_idx_s r = hta_idx_s_upd hta_idx_s r;

hta_ensure_idx_s ::
  forall a b c.
    (Eq a, Hashable a,
      Eq b) => HashedTa_ext_type a b c -> HashedTa_ext_type a b c;
hta_ensure_idx_s h =
  (case hta_idx_s h of {
    Nothing ->
      hta_idx_s_update (\ x -> Just (build_rule_index_s (hta_delta h))) h;
    Just x -> h;
  });

init_hta ::
  forall a b.
    Rbt Integer [(a, ())] -> [(Ta_rule a b)] -> HashedTa_ext_type a b ();
init_hta qi delta = hashedTa_ext qi delta Nothing Nothing Nothing ();

it_set_to_list ::
  forall x s a. ((x -> [x] -> [x]) -> s -> [a] -> [x]) -> s -> [x];
it_set_to_list iteratea s = iteratea (\ a b -> a : b) s [];

hs_to_list :: forall a. (Hashable a) => Rbt Integer [(a, ())] -> [a];
hs_to_list a = it_set_to_list hs_iterate a;

pa_initial ::
  forall qa l q.
    (Eq qa, Hashable qa, Hashable l, Eq q,
      Hashable q) => HashedTa_ext_type qa l () ->
                       HashedTa_ext_type q l () ->
                         (Rbt Integer [((qa, q), ())],
                           ([(qa, q)], [(Ta_rule (qa, q) l)]));
pa_initial h1 h2 =
  let {
    qip = hhh_cart (hta_Qi h1) (hta_Qi h2);
  } in (qip, (hs_to_list qip, ls_empty));

while :: forall a. (a -> Bool) -> (a -> a) -> a -> a;
while b c s = (if b s then while b c (c s) else s);

hta_prod' ::
  forall a c b.
    (Eq a, Hashable a, Eq c, Hashable c, Eq b,
      Hashable b) => HashedTa_ext_type a c () ->
                       HashedTa_ext_type b c () ->
                         HashedTa_ext_type (a, b) c ();
hta_prod' h1 h2 =
  let {
    a = while pa_cond (pa_step h1 h2) (pa_initial h1 h2);
    (q, aa) = a;
    (w, ab) = aa;
  } in init_hta (hhh_cart (hta_Qi h1) (hta_Qi h2)) ab;

hta_prod ::
  forall a c b.
    (Eq a, Hashable a, Eq c, Hashable c, Eq b,
      Hashable b) => HashedTa_ext_type a c () ->
                       HashedTa_ext_type b c () ->
                         HashedTa_ext_type (a, b) c ();
hta_prod h1 h2 = hta_prod' (hta_ensure_idx_s h1) (hta_ensure_idx_sf h2);

hashcode_nat :: Nat.Nat -> Integer;
hashcode_nat i = toInteger i;

instance Hashable Nat.Nat where {
  hashcode = hashcode_nat;
};

htai_mem :: Tree Nat.Nat -> HashedTa_ext_type Nat.Nat Nat.Nat () -> Bool;
htai_mem = hta_mem;

rqrm_add ::
  forall a b.
    (Eq a, Hashable a,
      Eq b) => a -> b -> Rbt Integer [(a, [b])] -> Rbt Integer [(a, [b])];
rqrm_add q r res =
  (case hm_lookup q res of {
    Nothing -> hm_update q (ls_ins r ls_empty) res;
    Just s -> hm_update q (ls_ins r s) res;
  });

fifo_isEmpty :: forall a. (Eq a) => ([a], [a]) -> Bool;
fifo_isEmpty f = f == ([], []);

lhh_union ::
  forall a.
    (Eq a, Hashable a) => [a] -> Rbt Integer [(a, ())] -> Rbt Integer [(a, ())];
lhh_union a = it_union ls_iterate hs_ins a;

brec_cond ::
  forall q l.
    (Eq q) => (Rbt Integer [(q, Tree l)],
                (([q], [q]), (Rbt Integer [(Ta_rule q l, Nat.Nat)], Maybe q)))
                -> Bool;
brec_cond a =
  let {
    (q, aa) = a;
    (w, ab) = aa;
    (rcm, qwit) = ab;
  } in not (fifo_isEmpty w) && is_none qwit;

brec_construct_witness ::
  forall q l.
    (Eq q, Hashable q,
      Hashable l) => Rbt Integer [(q, Tree l)] -> Ta_rule q l -> Tree l;
brec_construct_witness qm r =
  Node (rhsl r) (mapa (\ q -> the (hm_lookup q qm)) (rhsq r));

brec_inner_step ::
  forall q l.
    (Eq q, Hashable q, Eq l,
      Hashable l) => Rbt Integer [(q, ())] ->
                       Ta_rule q l ->
                         (Rbt Integer [(q, Tree l)],
                           (([q], [q]),
                             (Rbt Integer [(Ta_rule q l, Nat.Nat)], Maybe q)))
                           -> (Rbt Integer [(q, Tree l)],
                                (([q], [q]),
                                  (Rbt Integer [(Ta_rule q l, Nat.Nat)],
                                    Maybe q)));
brec_inner_step qi r =
  (\ (a @ (q, aa)) ->
    let {
      (w, ab) = aa;
      (rcm, qwit) = ab;
      c = the (hm_lookup r rcm);
      cond = c <= 1 && is_none (hm_lookup (lhs r) q);
      rcm' = hm_update r (minus_nat c 1) rcm;
      q' = (if cond then hm_update (lhs r) (brec_construct_witness q r) q
             else q);
      w' = (if cond then fifo_put (lhs r) w else w);
      qwit' = (if c <= 1 && hs_memb (lhs r) qi then Just (lhs r) else qwit);
    } in (q', (w', (rcm', qwit'))));

brec_step ::
  forall q l.
    (Eq q, Hashable q, Eq l,
      Hashable l) => Rbt Integer [(q, [(Ta_rule q l)])] ->
                       Rbt Integer [(q, ())] ->
                         (Rbt Integer [(q, Tree l)],
                           (([q], [q]),
                             (Rbt Integer [(Ta_rule q l, Nat.Nat)], Maybe q)))
                           -> (Rbt Integer [(q, Tree l)],
                                (([q], [q]),
                                  (Rbt Integer [(Ta_rule q l, Nat.Nat)],
                                    Maybe q)));
brec_step rqrm qi =
  (\ (a @ (q, aa)) ->
    let {
      (w, ab) = aa;
      (rcm, qwit) = ab;
      ac = fifo_get w;
      (qa, w') = ac;
    } in ls_iterate (brec_inner_step qi) (rqrm_lookup rqrm qa)
           (q, (w', (rcm, qwit))));

hta_empty :: forall q l. (Hashable q, Hashable l) => HashedTa_ext_type q l ();
hta_empty = init_hta hs_empty ls_empty;

ls_image :: forall a b. (Eq b) => (a -> b) -> [a] -> [b];
ls_image a = iflt_image ls_image_filter a;

hta_remap ::
  forall q qn l.
    (Hashable q, Eq qn, Hashable qn, Eq l,
      Hashable l) => (q -> qn) ->
                       HashedTa_ext_type q l () -> HashedTa_ext_type qn l ();
hta_remap f h =
  init_hta (hs_image f (hta_Qi h)) (ls_image (remap_rule f) (hta_delta h));

ls_union_dj :: forall a. [a] -> [a] -> [a];
ls_union_dj s1 s2 = revg s1 s2;

hashcode_of_usw ::
  forall c d. (Hashable c, Hashable d) => Ustate_wrapper c d -> Integer;
hashcode_of_usw (USW1 q) = hashcode q;
hashcode_of_usw (USW2 qa) = hashcode qa;

hashcode_ustate_wrapper ::
  forall a b. (Hashable a, Hashable b) => Ustate_wrapper a b -> Integer;
hashcode_ustate_wrapper a = hashcode_of_usw a;

instance (Hashable a, Hashable b) => Hashable (Ustate_wrapper a b) where {
  hashcode = hashcode_ustate_wrapper;
};

eq_ustate_wrapper ::
  forall qa q.
    (Eq qa, Eq q) => Ustate_wrapper qa q -> Ustate_wrapper qa q -> Bool;
eq_ustate_wrapper (USW2 b) (USW1 a) = False;
eq_ustate_wrapper (USW1 a) (USW2 b) = False;
eq_ustate_wrapper (USW2 q2) (USW2 q2') = q2 == q2';
eq_ustate_wrapper (USW1 q1) (USW1 q1') = q1 == q1';

instance (Eq a, Eq b) => Eq (Ustate_wrapper a b) where {
  a == b = eq_ustate_wrapper a b;
};

hta_union ::
  forall qa l q.
    (Eq qa, Hashable qa, Eq l, Hashable l, Eq q,
      Hashable q) => HashedTa_ext_type qa l () ->
                       HashedTa_ext_type q l () ->
                         HashedTa_ext_type (Ustate_wrapper qa q) l ();
hta_union h1 h2 =
  init_hta (hs_union (hs_image USW1 (hta_Qi h1)) (hs_image USW2 (hta_Qi h2)))
    (ls_union_dj (ls_image (remap_rule USW1) (hta_delta h1))
      (ls_image (remap_rule USW2) (hta_delta h2)));

list_to_ls :: forall a. (Eq a) => [a] -> [a];
list_to_ls a = remdups a;

rule_states_l :: forall a b. (Eq a) => Ta_rule a b -> [a];
rule_states_l (Rule q f qs) = ls_ins q (list_to_ls qs);

it_Union_image ::
  forall x sb sa s.
    ((x -> sb -> sb) -> sa -> sb -> sb) ->
      sb -> (s -> sb -> sb) -> (x -> s) -> sa -> sb;
it_Union_image it1 em3 un233 f s = it1 (\ x -> un233 (f x)) s em3;

llh_Union_image ::
  forall a b. (Eq b, Hashable b) => (a -> [b]) -> [a] -> Rbt Integer [(b, ())];
llh_Union_image a = it_Union_image ls_iterate hs_empty lhh_union a;

hta_delta_states ::
  forall a b c.
    (Eq a, Hashable a) => HashedTa_ext_type a b c -> Rbt Integer [(a, ())];
hta_delta_states h =
  llh_Union_image id
    (ls_image_filter (\ r -> Just (rule_states_l r)) (hta_delta h));

hta_states ::
  forall a b c.
    (Eq a, Hashable a) => HashedTa_ext_type a b c -> Rbt Integer [(a, ())];
hta_states h = hs_union (hta_Qi h) (hta_delta_states h);

hh_map_to_nat ::
  forall a.
    (Eq a, Hashable a) => Rbt Integer [(a, ())] -> Rbt Integer [(a, Nat.Nat)];
hh_map_to_nat a = map_to_nat hs_iterate hm_empty hm_update a;

hta_reindex ::
  forall b a.
    (Eq b, Hashable b, Eq a,
      Hashable a) => HashedTa_ext_type b a () -> HashedTa_ext_type Nat.Nat a ();
hta_reindex h =
  let {
    mp = hh_map_to_nat (hta_states h);
  } in hta_remap (\ q -> the (hm_lookup q mp)) h;

htai_prod ::
  HashedTa_ext_type Nat.Nat Nat.Nat () ->
    HashedTa_ext_type Nat.Nat Nat.Nat () ->
      HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_prod h1 h2 = hta_reindex (hta_prod h1 h2);

length_unique :: forall a. (Eq a) => [a] -> Nat.Nat;
length_unique [] = 0;
length_unique (x : xs) =
  (if member x xs then length_unique xs else suc (length_unique xs));

rs_iterate ::
  forall a sigma.
    (Linorder a) => (a -> sigma -> sigma) -> Rbt a () -> sigma -> sigma;
rs_iterate a = s_iterate rm_iterate a;

rs_size :: forall a. (Linorder a) => Rbt a () -> Nat.Nat;
rs_size a = it_size rs_iterate a;

it_set_to_fifo ::
  forall a s.
    ((a -> ([a], [a]) -> ([a], [a])) -> s -> ([a], [a]) -> ([a], [a])) ->
      s -> ([a], [a]);
it_set_to_fifo iteratea s = iteratea fifo_put s fifo_empty;

hs_to_fifo :: forall a. (Hashable a) => Rbt Integer [(a, ())] -> ([a], [a]);
hs_to_fifo a = it_set_to_fifo hs_iterate a;

build_rqrm ::
  forall q l.
    (Eq q, Hashable q, Eq l,
      Hashable l) => [(Ta_rule q l)] -> Rbt Integer [(q, [(Ta_rule q l)])];
build_rqrm delta =
  ls_iterate (\ r res -> foldla (\ resa q -> rqrm_add q r resa) res (rhsq r))
    delta hm_empty;

hta_add_qi ::
  forall q l.
    (Eq q, Hashable q,
      Hashable l) => q -> HashedTa_ext_type q l () -> HashedTa_ext_type q l ();
hta_add_qi qi h = init_hta (hs_ins qi (hta_Qi h)) (hta_delta h);

lll_inj_image_filter_cp ::
  forall a b c. (a -> b -> c) -> (a -> b -> Bool) -> [a] -> [b] -> [c];
lll_inj_image_filter_cp a =
  inj_image_filter_cp ls_iterate ls_iterate ls_empty ls_ins_dj a;

delta_prod_h ::
  forall qa l q.
    (Hashable qa, Eq l, Hashable l,
      Hashable q) => [(Ta_rule qa l)] ->
                       [(Ta_rule q l)] -> [(Ta_rule (qa, q) l)];
delta_prod_h delta_1 delta_2 =
  lll_inj_image_filter_cp r_prod
    (\ r1 r2 ->
      rhsl r1 == rhsl r2 && size_list (rhsq r1) == size_list (rhsq r2))
    delta_1 delta_2;

hta_prodWR ::
  forall a c d b e.
    (Eq a, Hashable a, Eq c, Hashable c, Eq b,
      Hashable b) => HashedTa_ext_type a c d ->
                       HashedTa_ext_type b c e -> HashedTa_ext_type (a, b) c ();
hta_prodWR h1 h2 =
  init_hta (hhh_cart (hta_Qi h1) (hta_Qi h2))
    (delta_prod_h (hta_delta h1) (hta_delta h2));

hta_reduce ::
  forall a b c.
    (Eq a, Hashable a,
      Eq b) => HashedTa_ext_type a b c ->
                 Rbt Integer [(a, ())] -> HashedTa_ext_type a b ();
hta_reduce h q =
  init_hta (hs_inter q (hta_Qi h))
    (ls_image_filter
      (\ r ->
        (if hs_memb (lhs r) q && list_all (\ qa -> hs_memb qa q) (rhsq r)
          then Just r else Nothing))
      (hta_delta h));

htai_empty :: HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_empty = hta_empty;

htai_union ::
  HashedTa_ext_type Nat.Nat Nat.Nat () ->
    HashedTa_ext_type Nat.Nat Nat.Nat () ->
      HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_union h1 h2 = hta_reindex (hta_union h1 h2);

ls_size :: forall a. [a] -> Nat.Nat;
ls_size a = it_size ls_iterate a;

brc_rcm_init ::
  forall q l.
    (Eq q, Hashable q, Eq l,
      Hashable l) => [(Ta_rule q l)] -> Rbt Integer [(Ta_rule q l, Nat.Nat)];
brc_rcm_init delta =
  ls_iterate (\ r -> hm_update r (length_unique (rhsq r))) delta hm_empty;

brc_initial ::
  forall q l.
    (Eq q, Hashable q, Eq l,
      Hashable l) => [(Ta_rule q l)] ->
                       (Rbt Integer [(q, ())],
                         ([q], Rbt Integer [(Ta_rule q l, Nat.Nat)]));
brc_initial delta =
  let {
    iq = brc_iq delta;
  } in (iq, (hs_to_list iq, brc_rcm_init delta));

htai_add_qi ::
  Nat.Nat ->
    HashedTa_ext_type Nat.Nat Nat.Nat () ->
      HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_add_qi = hta_add_qi;

htai_prodWR ::
  HashedTa_ext_type Nat.Nat Nat.Nat () ->
    HashedTa_ext_type Nat.Nat Nat.Nat () ->
      HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_prodWR h1 h2 = hta_reindex (hta_prodWR h1 h2);

sel_disjoint_witness ::
  forall b c a d. (b -> (c -> Maybe c) -> a) -> (c -> d -> Bool) -> b -> d -> a;
sel_disjoint_witness sel1 mem2 s1 s2 =
  sel1 s1 (\ x -> (if mem2 x s2 then Just x else Nothing));

hh_disjoint_witness ::
  forall a.
    (Eq a,
      Hashable a) => Rbt Integer [(a, ())] -> Rbt Integer [(a, ())] -> Maybe a;
hh_disjoint_witness a = sel_disjoint_witness hs_sel hs_memb a;

brec_initial ::
  forall q l.
    (Eq q, Hashable q, Eq l,
      Hashable l) => Rbt Integer [(q, ())] ->
                       [(Ta_rule q l)] ->
                         (Rbt Integer [(q, Tree l)],
                           (([q], [q]),
                             (Rbt Integer [(Ta_rule q l, Nat.Nat)], Maybe q)));
brec_initial qi delta =
  let {
    iq = brc_iq delta;
  } in (brec_iqm delta,
         (hs_to_fifo iq, (brc_rcm_init delta, hh_disjoint_witness iq qi)));

hta_add_rule ::
  forall q l.
    (Eq q, Hashable q, Eq l,
      Hashable l) => Ta_rule q l ->
                       HashedTa_ext_type q l () -> HashedTa_ext_type q l ();
hta_add_rule r h = init_hta (hta_Qi h) (ls_ins r (hta_delta h));

htai_add_rule ::
  Ta_rule Nat.Nat Nat.Nat ->
    HashedTa_ext_type Nat.Nat Nat.Nat () ->
      HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_add_rule = hta_add_rule;

hta_bwd_reduce ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext_type a b c -> HashedTa_ext_type a b ();
hta_bwd_reduce h =
  let {
    rqrm = build_rqrm (hta_delta h);
  } in hta_reduce h
         (fst (while brc_cond (brc_step rqrm) (brc_initial (hta_delta h))));

htai_bwd_reduce ::
  HashedTa_ext_type Nat.Nat Nat.Nat () -> HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_bwd_reduce = hta_bwd_reduce;

htai_ensure_idx_f ::
  HashedTa_ext_type Nat.Nat Nat.Nat () -> HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_ensure_idx_f = hta_ensure_idx_f;

htai_ensure_idx_s ::
  HashedTa_ext_type Nat.Nat Nat.Nat () -> HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_ensure_idx_s = hta_ensure_idx_s;

htai_ensure_idx_sf ::
  HashedTa_ext_type Nat.Nat Nat.Nat () -> HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_ensure_idx_sf = hta_ensure_idx_sf;

hta_is_empty_witness ::
  forall b a c.
    (Eq b, Hashable b, Eq a,
      Hashable a) => HashedTa_ext_type b a c -> Maybe (Tree a);
hta_is_empty_witness h =
  let {
    rqrm = build_rqrm (hta_delta h);
    a = while brec_cond (brec_step rqrm (hta_Qi h))
          (brec_initial (hta_Qi h) (hta_delta h));
    (q, aa) = a;
    (uu, ab) = aa;
    (uua, ac) = ab;
  } in (case ac of {
         Nothing -> Nothing;
         Just qa -> hm_lookup qa q;
       });

htai_is_empty_witness ::
  HashedTa_ext_type Nat.Nat Nat.Nat () -> Maybe (Tree Nat.Nat);
htai_is_empty_witness = hta_is_empty_witness;

}
