module Ta = 
struct

type color = R | B;;

let rec id x = x;;

type 'a eq = {eq : 'a -> 'a -> bool};;
let eq _A = _A.eq;;

type ('a, 'b) rbt = Empty |
  Tr of color * ('a, 'b) rbt * 'a * 'b * ('a, 'b) rbt;;

type ('a, 'b) ta_rule = Rule of 'a * 'b * 'a list;;

let rec lhs (Rule (q, l, qs)) = q;;

let rec leta s f = f s;;

type 'a ord = {less_eq : 'a -> 'a -> bool; less : 'a -> 'a -> bool};;
let less_eq _A = _A.less_eq;;
let less _A = _A.less;;

let rec hd (x :: xs) = x;;

let rec tl = function [] -> []
             | x :: xs -> xs;;

let rec suc n = Big_int.add_big_int n (Big_int.big_int_of_int 1);;

let rec balance
  x0 s t x3 = match x0, s, t, x3 with
    Tr (R, a, w, x, b), s, t, Tr (R, c, y, z, d) ->
      Tr (R, Tr (B, a, w, x, b), s, t, Tr (B, c, y, z, d))
    | Tr (R, Tr (R, a, w, x, b), s, t, c), y, z, Empty ->
        Tr (R, Tr (B, a, w, x, b), s, t, Tr (B, c, y, z, Empty))
    | Tr (R, Tr (R, a, w, x, b), s, t, c), y, z, Tr (B, va, vb, vc, vd) ->
        Tr (R, Tr (B, a, w, x, b), s, t,
             Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
    | Tr (R, Empty, w, x, Tr (R, b, s, t, c)), y, z, Empty ->
        Tr (R, Tr (B, Empty, w, x, b), s, t, Tr (B, c, y, z, Empty))
    | Tr (R, Tr (B, va, vb, vc, vd), w, x, Tr (R, b, s, t, c)), y, z, Empty ->
        Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
             Tr (B, c, y, z, Empty))
    | Tr (R, Empty, w, x, Tr (R, b, s, t, c)), y, z, Tr (B, va, vb, vc, vd) ->
        Tr (R, Tr (B, Empty, w, x, b), s, t,
             Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
    | Tr (R, Tr (B, ve, vf, vga, vha), w, x, Tr (R, b, s, t, c)), y, z,
        Tr (B, va, vb, vc, vd)
        -> Tr (R, Tr (B, Tr (B, ve, vf, vga, vha), w, x, b), s, t,
                Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
    | Empty, w, x, Tr (R, b, s, t, Tr (R, c, y, z, d)) ->
        Tr (R, Tr (B, Empty, w, x, b), s, t, Tr (B, c, y, z, d))
    | Tr (B, va, vb, vc, vd), w, x, Tr (R, b, s, t, Tr (R, c, y, z, d)) ->
        Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
             Tr (B, c, y, z, d))
    | Empty, w, x, Tr (R, Tr (R, b, s, t, c), y, z, Empty) ->
        Tr (R, Tr (B, Empty, w, x, b), s, t, Tr (B, c, y, z, Empty))
    | Empty, w, x, Tr (R, Tr (R, b, s, t, c), y, z, Tr (B, va, vb, vc, vd)) ->
        Tr (R, Tr (B, Empty, w, x, b), s, t,
             Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
    | Tr (B, va, vb, vc, vd), w, x, Tr (R, Tr (R, b, s, t, c), y, z, Empty) ->
        Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
             Tr (B, c, y, z, Empty))
    | Tr (B, va, vb, vc, vd), w, x,
        Tr (R, Tr (R, b, s, t, c), y, z, Tr (B, ve, vf, vga, vha))
        -> Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
                Tr (B, c, y, z, Tr (B, ve, vf, vga, vha)))
    | Empty, s, t, Empty -> Tr (B, Empty, s, t, Empty)
    | Empty, s, t, Tr (B, va, vb, vc, vd) ->
        Tr (B, Empty, s, t, Tr (B, va, vb, vc, vd))
    | Empty, s, t, Tr (B, va, vb, vc, Empty) ->
        Tr (B, Empty, s, t, Tr (B, va, vb, vc, Empty))
    | Empty, s, t, Tr (v, Empty, vb, vc, Empty) ->
        Tr (B, Empty, s, t, Tr (v, Empty, vb, vc, Empty))
    | Empty, s, t, Tr (v, Tr (B, ve, vf, vga, vha), vb, vc, Empty) ->
        Tr (B, Empty, s, t, Tr (v, Tr (B, ve, vf, vga, vha), vb, vc, Empty))
    | Empty, s, t, Tr (B, va, vb, vc, Tr (B, vfa, vg, vh, vi)) ->
        Tr (B, Empty, s, t, Tr (B, va, vb, vc, Tr (B, vfa, vg, vh, vi)))
    | Empty, s, t, Tr (v, Empty, vb, vc, Tr (B, vfa, vg, vh, vi)) ->
        Tr (B, Empty, s, t, Tr (v, Empty, vb, vc, Tr (B, vfa, vg, vh, vi)))
    | Empty, s, t,
        Tr (v, Tr (B, ve, vj, vka, vla), vb, vc, Tr (B, vfa, vg, vh, vi))
        -> Tr (B, Empty, s, t,
                Tr (v, Tr (B, ve, vj, vka, vla), vb, vc,
                     Tr (B, vfa, vg, vh, vi)))
    | Tr (B, va, vb, vc, vd), s, t, Empty ->
        Tr (B, Tr (B, va, vb, vc, vd), s, t, Empty)
    | Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vga, vha) ->
        Tr (B, Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vga, vha))
    | Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vga, Empty) ->
        Tr (B, Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vga, Empty))
    | Tr (B, va, vb, vc, vd), s, t, Tr (v, Empty, vf, vga, Empty) ->
        Tr (B, Tr (B, va, vb, vc, vd), s, t, Tr (v, Empty, vf, vga, Empty))
    | Tr (B, va, vb, vc, vd), s, t,
        Tr (v, Tr (B, vi, vj, vka, vla), vf, vga, Empty)
        -> Tr (B, Tr (B, va, vb, vc, vd), s, t,
                Tr (v, Tr (B, vi, vj, vka, vla), vf, vga, Empty))
    | Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vga, Tr (B, vja, vk, vl, vm))
        -> Tr (B, Tr (B, va, vb, vc, vd), s, t,
                Tr (B, ve, vf, vga, Tr (B, vja, vk, vl, vm)))
    | Tr (B, va, vb, vc, vd), s, t,
        Tr (v, Empty, vf, vga, Tr (B, vja, vk, vl, vm))
        -> Tr (B, Tr (B, va, vb, vc, vd), s, t,
                Tr (v, Empty, vf, vga, Tr (B, vja, vk, vl, vm)))
    | Tr (B, va, vb, vc, vd), s, t,
        Tr (v, Tr (B, vi, vn, vo, vp), vf, vga, Tr (B, vja, vk, vl, vm))
        -> Tr (B, Tr (B, va, vb, vc, vd), s, t,
                Tr (v, Tr (B, vi, vn, vo, vp), vf, vga,
                     Tr (B, vja, vk, vl, vm)))
    | Empty, s, t, Empty -> Tr (B, Empty, s, t, Empty)
    | Tr (B, va, vb, vc, vd), s, t, Empty ->
        Tr (B, Tr (B, va, vb, vc, vd), s, t, Empty)
    | Tr (B, Empty, vb, vc, vd), s, t, Empty ->
        Tr (B, Tr (B, Empty, vb, vc, vd), s, t, Empty)
    | Tr (v, Empty, vb, vc, Empty), s, t, Empty ->
        Tr (B, Tr (v, Empty, vb, vc, Empty), s, t, Empty)
    | Tr (v, Empty, vb, vc, Tr (B, ve, vf, vga, vha)), s, t, Empty ->
        Tr (B, Tr (v, Empty, vb, vc, Tr (B, ve, vf, vga, vha)), s, t, Empty)
    | Tr (B, Tr (B, vfa, vg, vh, vi), vb, vc, vd), s, t, Empty ->
        Tr (B, Tr (B, Tr (B, vfa, vg, vh, vi), vb, vc, vd), s, t, Empty)
    | Tr (v, Tr (B, vfa, vg, vh, vi), vb, vc, Empty), s, t, Empty ->
        Tr (B, Tr (v, Tr (B, vfa, vg, vh, vi), vb, vc, Empty), s, t, Empty)
    | Tr (v, Tr (B, vfa, vg, vh, vi), vb, vc, Tr (B, ve, vj, vka, vla)), s, t,
        Empty
        -> Tr (B, Tr (v, Tr (B, vfa, vg, vh, vi), vb, vc,
                       Tr (B, ve, vj, vka, vla)),
                s, t, Empty)
    | Empty, s, t, Tr (B, va, vb, vc, vd) ->
        Tr (B, Empty, s, t, Tr (B, va, vb, vc, vd))
    | Tr (B, ve, vf, vga, vha), s, t, Tr (B, va, vb, vc, vd) ->
        Tr (B, Tr (B, ve, vf, vga, vha), s, t, Tr (B, va, vb, vc, vd))
    | Tr (B, Empty, vf, vga, vha), s, t, Tr (B, va, vb, vc, vd) ->
        Tr (B, Tr (B, Empty, vf, vga, vha), s, t, Tr (B, va, vb, vc, vd))
    | Tr (v, Empty, vf, vga, Empty), s, t, Tr (B, va, vb, vc, vd) ->
        Tr (B, Tr (v, Empty, vf, vga, Empty), s, t, Tr (B, va, vb, vc, vd))
    | Tr (v, Empty, vf, vga, Tr (B, vi, vj, vka, vla)), s, t,
        Tr (B, va, vb, vc, vd)
        -> Tr (B, Tr (v, Empty, vf, vga, Tr (B, vi, vj, vka, vla)), s, t,
                Tr (B, va, vb, vc, vd))
    | Tr (B, Tr (B, vja, vk, vl, vm), vf, vga, vha), s, t,
        Tr (B, va, vb, vc, vd)
        -> Tr (B, Tr (B, Tr (B, vja, vk, vl, vm), vf, vga, vha), s, t,
                Tr (B, va, vb, vc, vd))
    | Tr (v, Tr (B, vja, vk, vl, vm), vf, vga, Empty), s, t,
        Tr (B, va, vb, vc, vd)
        -> Tr (B, Tr (v, Tr (B, vja, vk, vl, vm), vf, vga, Empty), s, t,
                Tr (B, va, vb, vc, vd))
    | Tr (v, Tr (B, vja, vk, vl, vm), vf, vga, Tr (B, vi, vn, vo, vp)), s, t,
        Tr (B, va, vb, vc, vd)
        -> Tr (B, Tr (v, Tr (B, vja, vk, vl, vm), vf, vga,
                       Tr (B, vi, vn, vo, vp)),
                s, t, Tr (B, va, vb, vc, vd));;

type 'a preorder = {ord_preorder : 'a ord};;

type 'a order = {preorder_order : 'a preorder};;

type 'a linorder = {order_linorder : 'a order};;

let rec ins _A
  f k v x3 = match f, k, v, x3 with f, k, v, Empty -> Tr (R, Empty, k, v, Empty)
    | f, k, v, Tr (B, l, x, y, r) ->
        (if less _A.order_linorder.preorder_order.ord_preorder k x
          then balance (ins _A f k v l) x y r
          else (if less _A.order_linorder.preorder_order.ord_preorder x k
                 then balance l x y (ins _A f k v r)
                 else Tr (B, l, x, f k y v, r)))
    | f, k, v, Tr (R, l, x, y, r) ->
        (if less _A.order_linorder.preorder_order.ord_preorder k x
          then Tr (R, ins _A f k v l, x, y, r)
          else (if less _A.order_linorder.preorder_order.ord_preorder x k
                 then Tr (R, l, x, y, ins _A f k v r)
                 else Tr (R, l, x, f k y v, r)));;

let rec rhsl (Rule (q, l, qs)) = l;;

let rec rhsq (Rule (q, l, qs)) = qs;;

type ('a, 'b) ustate_wrapper = USW1 of 'a | USW2 of 'b;;

let rec eqop _A a b = eq _A a b;;

let rec map
  f x1 = match f, x1 with f, [] -> []
    | f, x :: xs -> f x :: map f xs;;

let rec foldl
  f a x2 = match f, a, x2 with f, a, [] -> a
    | f, a, x :: xs -> foldl f (f a x) xs;;

let rec rev xs = foldl (fun xsa x -> x :: xsa) [] xs;;

let rec list_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, a :: lista -> f2 a lista
    | f1, f2, [] -> f1;;

let rec zip
  xs x1 = match xs, x1 with xs, [] -> []
    | xs, y :: ys -> (match xs with [] -> [] | z :: zs -> (z, y) :: zip zs ys);;

type 'a tree = Node of 'a * 'a tree list;;

let rec null = function [] -> true
               | x :: xs -> false;;

let rec revg
  x0 b = match x0, b with [], b -> b
    | a :: asa, b -> revg asa (a :: b);;

let eq_nat = ({eq = Big_int.eq_big_int} : Big_int.big_int eq);;

let rec paint
  c x1 = match c, x1 with c, Empty -> Empty
    | c, Tr (uu, l, k, v, r) -> Tr (c, l, k, v, r);;

let rec insertwithkey _A f k v t = paint B (ins _A f k v t);;

let rec insrt _A k v t = insertwithkey _A (fun uu uua nv -> nv) k v t;;

let rec r_prod
  (Rule (q1, l1, qs1)) (Rule (q2, l2, qs2)) = Rule ((q1, q2), l1, zip qs1 qs2);;

let ord_int =
  ({less_eq = Big_int.le_big_int; less = Big_int.lt_big_int} :
    Big_int.big_int ord);;

let rec map_of _B
  x0 k = match x0, k with
    (l, v) :: ps, k -> (if eqop _B l k then Some v else map_of _B ps k)
    | [], k -> None;;

let rec the (Some x) = x;;

let rec map_ofa _A
  x0 k = match x0, k with Empty, k -> None
    | Tr (uu, l, x, y, r), k ->
        (if less _A.order_linorder.preorder_order.ord_preorder k x
          then map_ofa _A l k
          else (if less _A.order_linorder.preorder_order.ord_preorder x k
                 then map_ofa _A r k else Some y));;

let rec inj_image_filter_cp
  iterate1 iterate2 empty3 insert_dj3 f p s1 s2 =
    iterate1
      (fun x ->
        iterate2 (fun y res -> (if p x y then insert_dj3 (f x y) res else res))
          s2)
      s1
      empty3;;

let rec cart
  it1 it2 empty3 ins3 s1 s2 =
    inj_image_filter_cp it1 it2 empty3 ins3 (fun a b -> (a, b))
      (fun x y -> true) s1 s2;;

let rec eq_list _A
  x0 x1 = match x0, x1 with a :: b, [] -> false
    | [], a :: b -> false
    | a :: lista, a' :: list' -> eq _A a a' && eq_list _A lista list'
    | [], [] -> true;;

let eq_lista _A = ({eq = eq_list _A} : ('a list) eq);;

let rec member _A
  x xa1 = match x, xa1 with x, [] -> false
    | x, y :: ys -> eqop _A x y || member _A x ys;;

let preorder_int = ({ord_preorder = ord_int} : Big_int.big_int preorder);;

let order_int = ({preorder_order = preorder_int} : Big_int.big_int order);;

let rec remdups _A
  = function [] -> []
    | x :: xs ->
        (if member _A x xs then remdups _A xs else x :: remdups _A xs);;

let rec it_add update iterate m1 m2 = iterate update m2 m1;;

let rec eq_ta_rule _Q _L
  (Rule (q, l, lista)) (Rule (q', l', list')) =
    eq _Q q q' && (eq _L l l' && eq_list _Q lista list');;

let eq_ta_rulea _A _B = ({eq = eq_ta_rule _A _B} : ('a, 'b) ta_rule eq);;

let rec fst (a, b) = a;;

let rec snd (a, b) = b;;

let rec fifo_get
  f = (match snd f with [] -> let rp = rev (fst f) in
                              (hd rp, ([], tl rp))
         | a :: l -> (a, (fst f, l)));;

let rec fifo_put a f = (a :: fst f, snd f);;

let rec list_all
  p x1 = match p, x1 with p, [] -> true
    | p, x :: xs -> p x && list_all p xs;;

let rec is_none = function Some x -> false
                  | None -> true;;

let rec iti_sel iti m f = iti is_none (fun k v res -> f k v) m None;;

let rec map_sng empt update k v = update k v empt;;

let rec minus_nat
  n m = Big_int.max_big_int Big_int.zero_big_int (Big_int.sub_big_int n m);;

let rec it_size
  iterate s = iterate (fun x -> suc) s (Big_int.big_int_of_int 0);;

let rec remap_rule f (Rule (q, l, qs)) = Rule (f q, l, map f qs);;

let linorder_int = ({order_linorder = order_int} : Big_int.big_int linorder);;

let rec lm_iterate_code
  f x1 sigma = match f, x1, sigma with f, [], sigma -> sigma
    | f, (k, v) :: l, sigma -> lm_iterate_code f l (f k v sigma);;

let rec lm_iterate a = lm_iterate_code a;;

let rec foldwithkey _A
  f x1 v = match f, x1, v with f, Empty, v -> v
    | f, Tr (c, lt, k, x, rt), v ->
        foldwithkey _A f rt (f k x (foldwithkey _A f lt v));;

let rec rm_iterate _K f t sigma_0 = foldwithkey _K f t sigma_0;;

let rec hm_iterate _D
  f m sigma_0 = rm_iterate _D (fun hc -> lm_iterate f) m sigma_0;;

let rec update _Key
  k v x2 = match k, v, x2 with k, v, [] -> [(k, v)]
    | k, v, p :: ps ->
        (if eqop _Key (fst p) k then (k, v) :: ps
          else p :: update _Key k v ps);;

let rec lm_update _A a = update _A a;;

let lm_empty : 'a list = []

let rec lm_sng _A a = map_sng lm_empty (lm_update _A) a;;

let rec rm_update _A a = insrt _A a;;

let rec rm_lookup _B k m = map_ofa _B m k;;

let rec option_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, Some a -> f2 a
    | f1, f2, None -> f1;;

type 'a hashable = {hashcode : 'a -> Big_int.big_int};;
let hashcode _A = _A.hashcode;;

let rec hm_update (_K1, _K2)
  k v m =
    let hc = hashcode _K2 k in
    (match rm_lookup linorder_int hc m
       with None -> rm_update linorder_int hc (lm_sng _K1 k v) m
       | Some bm -> rm_update linorder_int hc (lm_update _K1 k v bm) m);;

let rec hm_add (_A1, _A2)
  a = it_add (hm_update (_A1, _A2)) (hm_iterate linorder_int) a;;

let rec lm_iteratei
  c f x2 sigma = match c, f, x2, sigma with c, f, [], sigma -> sigma
    | c, f, (k, v) :: l, sigma ->
        (if c sigma then lm_iteratei c f l (f k v sigma) else sigma);;

let rec lm_sel a = iti_sel lm_iteratei a;;

let rec rm_iteratei
  c f x2 sigma = match c, f, x2, sigma with c, f, Empty, sigma -> sigma
    | c, f, Tr (col, l, k, v, r), sigma ->
        (if c sigma then rm_iteratei c f l (rm_iteratei c f r (f k v sigma))
          else sigma);;

let rec rm_sel a = iti_sel rm_iteratei a;;

let rec hm_sel _K m f = rm_sel m (fun hc lm -> lm_sel lm f);;

let rec s_ins update x s = update x () s;;

let rec hs_ins (_A1, _A2) a = s_ins (hm_update (_A1, _A2)) a;;

let rec s_sel sel s f = sel s (fun u v -> f u);;

let rec hs_sel _A a = s_sel (hm_sel _A) a;;

let rec size_list
  = function [] -> (Big_int.big_int_of_int 0)
    | a :: lista ->
        Big_int.add_big_int (size_list lista) (suc (Big_int.big_int_of_int 0));;

let rec eqa _A _B (x1, y1) (x2, y2) = eqop _A x1 x2 && eqop _B y1 y2;;

let eqb _A _B = ({eq = eqa _A _B} : ('a * 'b) eq);;

let rec it_inter
  iterate1 memb2 empt3 insrt3 s1 s2 =
    iterate1 (fun x s -> (if memb2 x s2 then insrt3 x s else s)) s1 empt3;;

let rec it_union iterate1 insrt2 s1 s2 = iterate1 insrt2 s1 s2;;

let rm_empty : ('a, 'b) rbt = Empty

let hm_empty : ('a, 'b) rbt = rm_empty

let rec s_empty empt = empt;;

let rec hs_empty _A = s_empty hm_empty;;

let rec ls_iteratei
  c f x2 sigma = match c, f, x2, sigma with c, f, [], sigma -> sigma
    | c, f, x :: l, sigma ->
        (if c sigma then ls_iteratei c f l (f x sigma) else sigma);;

let rec iti_iterate iti = iti (fun x -> true);;

let rec ls_iterate a = iti_iterate ls_iteratei a;;

let rec it_image_filter
  iterate1 empty2 ins2 f s =
    iterate1 (fun x res -> (match f x with None -> res | Some v -> ins2 v res))
      s
      empty2;;

let rec lh_image_filter (_B1, _B2)
  a = it_image_filter ls_iterate (hs_empty _B2) (hs_ins (_B1, _B2)) a;;

let rec brc_iq (_Q1, _Q2)
  delta =
    lh_image_filter (_Q1, _Q2)
      (fun r -> (if null (rhsq r) then Some (lhs r) else None)) delta;;

type ('a, 'b, 'c) hashedTa_ext_type =
  Abs_hashedTa_ext_type of
    ((Big_int.big_int, (('a * unit) list)) rbt *
      (('a, 'b) ta_rule list *
        ((Big_int.big_int, (('b * ('a, 'b) ta_rule list) list)) rbt option *
          ((Big_int.big_int, (('a * ('a, 'b) ta_rule list) list)) rbt option *
            ((Big_int.big_int, ((('a * 'b) * ('a, 'b) ta_rule list) list))
               rbt option
              * 'c)))));;

let rec rep_hashedTa_ext_type (Abs_hashedTa_ext_type y) = y;;

let rec hta_idx_f_sel r = fst (snd (snd (rep_hashedTa_ext_type r)));;

let rec hta_idx_f a = hta_idx_f_sel a;;

let ls_empty : 'a list = []

let rec lm_lookup _B k m = map_of _B m k;;

let rec hm_lookup (_K1, _K2)
  k m = (match rm_lookup linorder_int (hashcode _K2 k) m with None -> None
           | Some a -> lm_lookup _K1 k a);;

let rec idx_lookup
  mlookup tempty i m = (match mlookup i m with None -> tempty | Some s -> s);;

let rec hl_idx_lookup (_A1, _A2)
  a = idx_lookup (hm_lookup (_A1, _A2)) ls_empty a;;

let rec hta_lookup_f (_B1, _B2)
  f h = hl_idx_lookup (_B1, _B2) f (the (hta_idx_f h));;

let rec ls_memb _A a = member _A a;;

let rec list_all_zip
  p x1 x2 = match p, x1, x2 with p, [], [] -> true
    | p, a :: asa, b :: bs -> p a b && list_all_zip p asa bs
    | p, v :: vaa, [] -> false
    | p, [], va :: vab -> false;;

let rec ta_rule_case f1 (Rule (q, l, lista)) = f1 q l lista;;

let rec ls_ins _A x l = (if member _A x l then l else x :: l);;

let rec ls_image_filter _B
  a = it_image_filter ls_iterate ls_empty (ls_ins _B) a;;

let rec faccs' _A (_B1, _B2)
  h (Node (f, ts)) =
    let qs = map (faccs' _A (_B1, _B2) h) ts in
    ls_image_filter _A
      (fun ((Rule (q, f', qsa)) as r) ->
        (if list_all_zip (fun qa qaa -> ls_memb _A qaa qa) qs qsa
          then Some (lhs r) else None))
      (hta_lookup_f (_B1, _B2) f h);;

let rec hta_Qi_sel r = fst (rep_hashedTa_ext_type r);;

let rec hta_Qi a = hta_Qi_sel a;;

let fifo_empty : 'a list * 'a list = ([], [])

let rec s_memb lookup x s = not (is_none (lookup x s));;

let rec hs_memb (_A1, _A2) a = s_memb (hm_lookup (_A1, _A2)) a;;

let rec s_iterate iterate f s sigma_0 = iterate (fun k v -> f k) s sigma_0;;

let rec hs_iterate _A a = s_iterate (hm_iterate linorder_int) a;;

let rec hs_size _A a = it_size (hs_iterate _A) a;;

let rec idx_build_stepfun
  mlookup mupdate tempty tinsert f x m =
    let i = f x in
    (match mlookup i m with None -> mupdate i (tinsert x tempty) m
       | Some s -> mupdate i (tinsert x s) m);;

let rec idx_build
  mempty mlookup mupdate tempty tinsert siterate f s =
    siterate (idx_build_stepfun mlookup mupdate tempty tinsert f) s mempty;;

let rec hta_delta_sel r = fst (snd (rep_hashedTa_ext_type r));;

let rec hta_delta a = hta_delta_sel a;;

let rec hll_idx_build _A (_B1, _B2)
  a = idx_build hm_empty (hm_lookup (_B1, _B2)) (hm_update (_B1, _B2)) ls_empty
        (ls_ins _A) ls_iterate a;;

let rec build_rule_index _Q _L (_I1, _I2)
  a = hll_idx_build (eq_ta_rulea _Q _L) (_I1, _I2) a;;

let rec build_rule_index_f _B (_A1, _A2)
  delta = build_rule_index _B _A1 (_A1, _A2) rhsl delta;;

let rec more_sel r = snd (snd (snd (snd (snd (rep_hashedTa_ext_type r)))));;

let rec hta_idx_sf_sel
  r = fst (snd (snd (snd (snd (rep_hashedTa_ext_type r)))));;

let rec hta_idx_s_sel r = fst (snd (snd (snd (rep_hashedTa_ext_type r))));;

let rec hashedTa_ext
  hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more =
    Abs_hashedTa_ext_type
      (hta_Qi, (hta_delta, (hta_idx_f, (hta_idx_s, (hta_idx_sf, more)))));;

let rec hta_idx_f_upd
  hta_idx_f r =
    hashedTa_ext (hta_Qi_sel r) (hta_delta_sel r) (hta_idx_f (hta_idx_f_sel r))
      (hta_idx_s_sel r) (hta_idx_sf_sel r) (more_sel r);;

let rec hta_idx_f_update hta_idx_f r = hta_idx_f_upd hta_idx_f r;;

let rec hta_ensure_idx_f _A (_B1, _B2)
  h = (match hta_idx_f h
         with None ->
           hta_idx_f_update
             (fun x -> Some (build_rule_index_f _A (_B1, _B2) (hta_delta h))) h
         | Some x -> h);;

let rec ls_ball l p = list_all p l;;

let rec ball_disjoint ball1 memb2 s1 s2 = ball1 s1 (fun x -> not (memb2 x s2));;

let rec lh_disjoint (_A1, _A2)
  a = ball_disjoint ls_ball (hs_memb (_A1, _A2)) a;;

let rec hta_mem' (_A1, _A2) (_B1, _B2)
  t h = not (lh_disjoint (_B1, _B2) (faccs' _B1 (_A1, _A2) h t) (hta_Qi h));;

let rec hta_mem (_A1, _A2) (_B1, _B2)
  t h = hta_mem' (_A1, _A2) (_B1, _B2) t (hta_ensure_idx_f _B1 (_A1, _A2) h);;

let rec split f (a, b) = f a b;;

let rec pa_cond _Qa _Q _L
  s = let a = s in
      let (q, aa) = a in
      let (w, delta_d) = aa in
      not (null w);;

let rec hta_idx_s a = hta_idx_s_sel a;;

let rec hta_lookup_s (_A1, _A2)
  q h = hl_idx_lookup (_A1, _A2) q (the (hta_idx_s h));;

let rec hta_idx_sf a = hta_idx_sf_sel a;;

let rec prod_case f1 (a, b) = f1 a b;;

let rec hashcodea _A _B
  x = let (a, b) = x in
      Big_int.add_big_int (hashcode _A a) (hashcode _B b);;

let hashable _A _B = ({hashcode = hashcodea _A _B} : ('a * 'b) hashable);;

let rec hta_lookup_sf (_A1, _A2) (_B1, _B2)
  q f h =
    hl_idx_lookup (eqb _A1 _B1, hashable _A2 _B2) (q, f) (the (hta_idx_sf h));;

let rec ls_ins_dj x l = x :: l;;

let rec pa_upd_rule (_A1, _A2) (_B1, _B2)
  q w x2 = match q, w, x2 with q, w, [] -> (q, w)
    | q, w, qp :: qs ->
        (if not (hs_memb (eqb _A1 _B1, hashable _A2 _B2) qp q)
          then pa_upd_rule (_A1, _A2) (_B1, _B2)
                 (hs_ins (eqb _A1 _B1, hashable _A2 _B2) qp q) (qp :: w) qs
          else pa_upd_rule (_A1, _A2) (_B1, _B2) q w qs);;

let rec pa_step (_Qa1, _Qa2) (_L1, _L2) (_Q1, _Q2)
  h1 h2 s =
    let a = s in
    let (q, aa) = a in
    let (w, delta_d) = aa in
    let ab = hd w in
    let (q1, q2) = ab in
    ls_iterate
      (fun r1 ->
        ls_iterate
          (fun r2 res ->
            (if eqop eq_nat (size_list (rhsq r1)) (size_list (rhsq r2))
              then let rp = r_prod r1 r2 in
                   let ac = res in
                   let (qa, ad) = ac in
                   let (wa, delta_da) = ad in
                   let ae = pa_upd_rule (_Qa1, _Qa2) (_Q1, _Q2) qa wa (rhsq rp)
                     in
                   let (q', w') = ae in
                   (q', (w', ls_ins_dj rp delta_da))
              else res))
          (hta_lookup_sf (_Q1, _Q2) (_L1, _L2) q2 (rhsl r1) h2))
      (hta_lookup_s (_Qa1, _Qa2) q1 h1) (q, (tl w, delta_d));;

let rec map_to_nat
  iterate1 empty2 update2 s =
    snd (iterate1
           (fun x ((c, m) as a) ->
             (Big_int.add_big_int c (Big_int.big_int_of_int 1), update2 x c m))
           s
          ((Big_int.big_int_of_int 0), empty2));;

let rec hs_image_filter _A (_B1, _B2)
  a = it_image_filter (hs_iterate _A) (hs_empty _B2) (hs_ins (_B1, _B2)) a;;

let rec iflt_image iflt f s = iflt (fun x -> Some (f x)) s;;

let rec hs_image _A (_B1, _B2)
  a = iflt_image (hs_image_filter _A (_B1, _B2)) a;;

let rec hm_update_dj (_A1, _A2) a = hm_update (_A1, _A2) a;;

let rec s_ins_dj update_dj x s = update_dj x () s;;

let rec hs_ins_dj (_A1, _A2) a = s_ins_dj (hm_update_dj (_A1, _A2)) a;;

let rec hs_inter (_A1, _A2)
  a = it_inter (hs_iterate _A2) (hs_memb (_A1, _A2)) (hs_empty _A2)
        (hs_ins_dj (_A1, _A2)) a;;

let rec s_union add = add;;

let rec hs_union (_A1, _A2) a = s_union (hm_add (_A1, _A2)) a;;

let rec hhh_cart (_A1, _A2) (_B1, _B2)
  a = cart (hs_iterate _A2) (hs_iterate _B2) (hs_empty (hashable _A2 _B2))
        (hs_ins_dj (eqb _A1 _B1, hashable _A2 _B2)) a;;

let rec brc_cond _Q _L
  a = let (q, aa) = a in
      let (w, rcm) = aa in
      not (null w);;

let rec rqrm_lookup (_B1, _B2)
  rqrm q =
    (match hm_lookup (_B1, _B2) q rqrm with None -> ls_empty | Some s -> s);;

let rec hashcode_of_list _A
  = function [] -> (Big_int.big_int_of_int 0)
    | x :: xs -> Big_int.add_big_int (hashcode _A x) (hashcode_of_list _A xs);;

let rec hashcode_list _A a = hashcode_of_list _A a;;

let rec hashcode_of_ta_rule _C _D
  (Rule (q, f, qs)) =
    Big_int.add_big_int (Big_int.add_big_int (hashcode _C q) (hashcode _D f))
      (hashcode_list _C qs);;

let rec hashcode_ta_rule _A _B a = hashcode_of_ta_rule _A _B a;;

let hashable_ta_rule _A _B =
  ({hashcode = hashcode_ta_rule _A _B} : ('a, 'b) ta_rule hashable);;

let rec brc_inner_step (_Q1, _Q2) (_L1, _L2)
  r = (fun ((q, aa) as a) ->
        let (w, rcm) = aa in
        let c =
          the (hm_lookup (eq_ta_rulea _Q1 _L1, hashable_ta_rule _Q2 _L2) r rcm)
          in
        let rcm' =
          hm_update (eq_ta_rulea _Q1 _L1, hashable_ta_rule _Q2 _L2) r
            (minus_nat c (Big_int.big_int_of_int 1)) rcm
          in
        let q' =
          (if Big_int.le_big_int c (Big_int.big_int_of_int 1)
            then hs_ins (_Q1, _Q2) (lhs r) q else q)
          in
        let w' =
          (if Big_int.le_big_int c (Big_int.big_int_of_int 1) &&
                not (hs_memb (_Q1, _Q2) (lhs r) q)
            then lhs r :: w else w)
          in
        (q', (w', rcm')));;

let rec brc_step (_Q1, _Q2) (_L1, _L2)
  rqrm =
    (fun ((q, aa) as a) ->
      let (w, rcm) = aa in
      ls_iterate (brc_inner_step (_Q1, _Q2) (_L1, _L2))
        (rqrm_lookup (_Q1, _Q2) rqrm (hd w)) (q, (tl w, rcm)));;

let rec brec_iqm (_Q1, _Q2) _L
  delta =
    ls_iterate
      (fun r m ->
        (if null (rhsq r)
          then hm_update (_Q1, _Q2) (lhs r) (Node (rhsl r, [])) m else m))
      delta hm_empty;;

let rec build_rule_index_sf (_A1, _A2) (_B1, _B2)
  delta =
    build_rule_index _A1 _B1 (eqb _A1 _B1, hashable _A2 _B2)
      (fun r -> (lhs r, rhsl r)) delta;;

let rec hta_idx_sf_upd
  hta_idx_sf r =
    hashedTa_ext (hta_Qi_sel r) (hta_delta_sel r) (hta_idx_f_sel r)
      (hta_idx_s_sel r) (hta_idx_sf (hta_idx_sf_sel r)) (more_sel r);;

let rec hta_idx_sf_update hta_idx_sf r = hta_idx_sf_upd hta_idx_sf r;;

let rec hta_ensure_idx_sf (_A1, _A2) (_B1, _B2)
  h = (match hta_idx_sf h
         with None ->
           hta_idx_sf_update
             (fun x ->
               Some (build_rule_index_sf (_A1, _A2) (_B1, _B2) (hta_delta h)))
             h
         | Some x -> h);;

let rec build_rule_index_s (_A1, _A2) _B
  delta = build_rule_index _A1 _B (_A1, _A2) lhs delta;;

let rec hta_idx_s_upd
  hta_idx_s r =
    hashedTa_ext (hta_Qi_sel r) (hta_delta_sel r) (hta_idx_f_sel r)
      (hta_idx_s (hta_idx_s_sel r)) (hta_idx_sf_sel r) (more_sel r);;

let rec hta_idx_s_update hta_idx_s r = hta_idx_s_upd hta_idx_s r;;

let rec hta_ensure_idx_s (_A1, _A2) _B
  h = (match hta_idx_s h
         with None ->
           hta_idx_s_update
             (fun x -> Some (build_rule_index_s (_A1, _A2) _B (hta_delta h))) h
         | Some x -> h);;

let rec init_hta qi delta = hashedTa_ext qi delta None None None ();;

let rec it_set_to_list iterate s = iterate (fun a b -> a :: b) s [];;

let rec hs_to_list _A a = it_set_to_list (hs_iterate _A) a;;

let rec pa_initial (_Qa1, _Qa2) _L (_Q1, _Q2)
  h1 h2 =
    let qip = hhh_cart (_Qa1, _Qa2) (_Q1, _Q2) (hta_Qi h1) (hta_Qi h2) in
    (qip, (hs_to_list (hashable _Qa2 _Q2) qip, ls_empty));;

let rec whilea b c s = (if b s then whilea b c (c s) else s);;

let rec hta_prod' (_A1, _A2) (_C1, _C2) (_B1, _B2)
  h1 h2 =
    let a =
      whilea (pa_cond _A2 _B2 _C2)
        (pa_step (_A1, _A2) (_C1, _C2) (_B1, _B2) h1 h2)
        (pa_initial (_A1, _A2) _C2 (_B1, _B2) h1 h2)
      in
    let (q, aa) = a in
    let (w, ab) = aa in
    init_hta (hhh_cart (_A1, _A2) (_B1, _B2) (hta_Qi h1) (hta_Qi h2)) ab;;

let rec hta_prod (_A1, _A2) (_C1, _C2) (_B1, _B2)
  h1 h2 =
    hta_prod' (_A1, _A2) (_C1, _C2) (_B1, _B2)
      (hta_ensure_idx_s (_A1, _A2) _C1 h1)
      (hta_ensure_idx_sf (_B1, _B2) (_C1, _C2) h2);;

let rec hashcode_nat i = i;;

let hashable_nat = ({hashcode = hashcode_nat} : Big_int.big_int hashable);;

let rec htai_mem x = hta_mem (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;;

let rec rqrm_add (_A1, _A2) _B
  q r res =
    (match hm_lookup (_A1, _A2) q res
       with None -> hm_update (_A1, _A2) q (ls_ins _B r ls_empty) res
       | Some s -> hm_update (_A1, _A2) q (ls_ins _B r s) res);;

let rec fifo_isEmpty _A f = eqop (eqb (eq_lista _A) (eq_lista _A)) f ([], []);;

let rec lhh_union (_A1, _A2) a = it_union ls_iterate (hs_ins (_A1, _A2)) a;;

let rec brec_cond _Q
  a = let (q, aa) = a in
      let (w, ab) = aa in
      let (rcm, qwit) = ab in
      not (fifo_isEmpty _Q w) && is_none qwit;;

let rec brec_construct_witness (_Q1, _Q2) _L
  qm r =
    Node (rhsl r, map (fun q -> the (hm_lookup (_Q1, _Q2) q qm)) (rhsq r));;

let rec brec_inner_step (_Q1, _Q2) (_L1, _L2)
  qi r =
    (fun ((q, aa) as a) ->
      let (w, ab) = aa in
      let (rcm, qwit) = ab in
      let c =
        the (hm_lookup (eq_ta_rulea _Q1 _L1, hashable_ta_rule _Q2 _L2) r rcm) in
      let cond =
        Big_int.le_big_int c (Big_int.big_int_of_int 1) &&
          is_none (hm_lookup (_Q1, _Q2) (lhs r) q)
        in
      let rcm' =
        hm_update (eq_ta_rulea _Q1 _L1, hashable_ta_rule _Q2 _L2) r
          (minus_nat c (Big_int.big_int_of_int 1)) rcm
        in
      let q' =
        (if cond
          then hm_update (_Q1, _Q2) (lhs r)
                 (brec_construct_witness (_Q1, _Q2) _L2 q r) q
          else q)
        in
      let w' = (if cond then fifo_put (lhs r) w else w) in
      let qwit' =
        (if Big_int.le_big_int c (Big_int.big_int_of_int 1) &&
              hs_memb (_Q1, _Q2) (lhs r) qi
          then Some (lhs r) else qwit)
        in
      (q', (w', (rcm', qwit'))));;

let rec brec_step (_Q1, _Q2) (_L1, _L2)
  rqrm qi =
    (fun ((q, aa) as a) ->
      let (w, ab) = aa in
      let (rcm, qwit) = ab in
      let ac = fifo_get w in
      let (qa, w') = ac in
      ls_iterate (brec_inner_step (_Q1, _Q2) (_L1, _L2) qi)
        (rqrm_lookup (_Q1, _Q2) rqrm qa) (q, (w', (rcm, qwit))));;

let rec hta_empty _Q _L = init_hta (hs_empty _Q) ls_empty;;

let rec ls_image _B a = iflt_image (ls_image_filter _B) a;;

let rec hta_remap _Q (_Qn1, _Qn2) (_L1, _L2)
  f h = init_hta (hs_image _Q (_Qn1, _Qn2) f (hta_Qi h))
          (ls_image (eq_ta_rulea _Qn1 _L1) (remap_rule f) (hta_delta h));;

let rec ls_union_dj s1 s2 = revg s1 s2;;

let rec hashcode_of_usw _C _D
  = function USW1 q -> hashcode _C q
    | USW2 qa -> hashcode _D qa;;

let rec hashcode_ustate_wrapper _A _B a = hashcode_of_usw _A _B a;;

let hashable_ustate_wrapper _A _B =
  ({hashcode = hashcode_ustate_wrapper _A _B} :
    ('a, 'b) ustate_wrapper hashable);;

let rec eq_ustate_wrapper _Qa _Q
  x0 x1 = match x0, x1 with USW2 b, USW1 a -> false
    | USW1 a, USW2 b -> false
    | USW2 q2, USW2 q2' -> eq _Q q2 q2'
    | USW1 q1, USW1 q1' -> eq _Qa q1 q1';;

let eq_ustate_wrappera _A _B =
  ({eq = eq_ustate_wrapper _A _B} : ('a, 'b) ustate_wrapper eq);;

let rec hta_union (_Qa1, _Qa2) (_L1, _L2) (_Q1, _Q2)
  h1 h2 =
    init_hta
      (hs_union (eq_ustate_wrappera _Qa1 _Q1, hashable_ustate_wrapper _Qa2 _Q2)
        (hs_image _Qa2
          (eq_ustate_wrappera _Qa1 _Q1, hashable_ustate_wrapper _Qa2 _Q2)
          (fun a -> USW1 a) (hta_Qi h1))
        (hs_image _Q2
          (eq_ustate_wrappera _Qa1 _Q1, hashable_ustate_wrapper _Qa2 _Q2)
          (fun a -> USW2 a) (hta_Qi h2)))
      (ls_union_dj
        (ls_image (eq_ta_rulea (eq_ustate_wrappera _Qa1 _Q1) _L1)
          (remap_rule (fun a -> USW1 a)) (hta_delta h1))
        (ls_image (eq_ta_rulea (eq_ustate_wrappera _Qa1 _Q1) _L1)
          (remap_rule (fun a -> USW2 a)) (hta_delta h2)));;

let rec list_to_ls _A a = remdups _A a;;

let rec rule_states_l _A (Rule (q, f, qs)) = ls_ins _A q (list_to_ls _A qs);;

let rec it_Union_image it1 em3 un233 f s = it1 (fun x -> un233 (f x)) s em3;;

let rec llh_Union_image (_B1, _B2)
  a = it_Union_image ls_iterate (hs_empty _B2) (lhh_union (_B1, _B2)) a;;

let rec hta_delta_states (_A1, _A2)
  h = llh_Union_image (_A1, _A2) id
        (ls_image_filter (eq_lista _A1) (fun r -> Some (rule_states_l _A1 r))
          (hta_delta h));;

let rec hta_states (_A1, _A2)
  h = hs_union (_A1, _A2) (hta_Qi h) (hta_delta_states (_A1, _A2) h);;

let rec hh_map_to_nat (_A1, _A2)
  a = map_to_nat (hs_iterate _A2) hm_empty (hm_update (_A1, _A2)) a;;

let rec hta_reindex (_B1, _B2) (_A1, _A2)
  h = let mp = hh_map_to_nat (_B1, _B2) (hta_states (_B1, _B2) h) in
      hta_remap _B2 (eq_nat, hashable_nat) (_A1, _A2)
        (fun q -> the (hm_lookup (_B1, _B2) q mp)) h;;

let rec htai_prod
  h1 h2 =
    hta_reindex (eqb eq_nat eq_nat, hashable hashable_nat hashable_nat)
      (eq_nat, hashable_nat)
      (hta_prod (eq_nat, hashable_nat) (eq_nat, hashable_nat)
        (eq_nat, hashable_nat) h1 h2);;

let rec length_unique _A
  = function [] -> (Big_int.big_int_of_int 0)
    | x :: xs ->
        (if member _A x xs then length_unique _A xs
          else suc (length_unique _A xs));;

let rec rs_iterate _A a = s_iterate (rm_iterate _A) a;;

let rec rs_size _A a = it_size (rs_iterate _A) a;;

let rec it_set_to_fifo iterate s = iterate fifo_put s fifo_empty;;

let rec hs_to_fifo _A a = it_set_to_fifo (hs_iterate _A) a;;

let rec build_rqrm (_Q1, _Q2) (_L1, _L2)
  delta =
    ls_iterate
      (fun r res ->
        foldl (fun resa q -> rqrm_add (_Q1, _Q2) (eq_ta_rulea _Q1 _L1) q r resa)
          res (rhsq r))
      delta hm_empty;;

let rec hta_add_qi (_Q1, _Q2) _L
  qi h = init_hta (hs_ins (_Q1, _Q2) qi (hta_Qi h)) (hta_delta h);;

let rec lll_inj_image_filter_cp
  a = inj_image_filter_cp ls_iterate ls_iterate ls_empty ls_ins_dj a;;

let rec delta_prod_h _Qa (_L1, _L2) _Q
  delta_1 delta_2 =
    lll_inj_image_filter_cp r_prod
      (fun r1 r2 ->
        eqop _L1 (rhsl r1) (rhsl r2) &&
          eqop eq_nat (size_list (rhsq r1)) (size_list (rhsq r2)))
      delta_1 delta_2;;

let rec hta_prodWR (_A1, _A2) (_C1, _C2) (_B1, _B2)
  h1 h2 =
    init_hta (hhh_cart (_A1, _A2) (_B1, _B2) (hta_Qi h1) (hta_Qi h2))
      (delta_prod_h _A2 (_C1, _C2) _B2 (hta_delta h1) (hta_delta h2));;

let rec hta_reduce (_A1, _A2) _B
  h q = init_hta (hs_inter (_A1, _A2) q (hta_Qi h))
          (ls_image_filter (eq_ta_rulea _A1 _B)
            (fun r ->
              (if hs_memb (_A1, _A2) (lhs r) q &&
                    list_all (fun qa -> hs_memb (_A1, _A2) qa q) (rhsq r)
                then Some r else None))
            (hta_delta h));;

let htai_empty : (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext_type =
  hta_empty hashable_nat hashable_nat

let rec htai_union
  h1 h2 =
    hta_reindex
      (eq_ustate_wrappera eq_nat eq_nat,
        hashable_ustate_wrapper hashable_nat hashable_nat)
      (eq_nat, hashable_nat)
      (hta_union (eq_nat, hashable_nat) (eq_nat, hashable_nat)
        (eq_nat, hashable_nat) h1 h2);;

let rec ls_size a = it_size ls_iterate a;;

let rec brc_rcm_init (_Q1, _Q2) (_L1, _L2)
  delta =
    ls_iterate
      (fun r ->
        hm_update (eq_ta_rulea _Q1 _L1, hashable_ta_rule _Q2 _L2) r
          (length_unique _Q1 (rhsq r)))
      delta hm_empty;;

let rec brc_initial (_Q1, _Q2) (_L1, _L2)
  delta =
    let iq = brc_iq (_Q1, _Q2) delta in
    (iq, (hs_to_list _Q2 iq, brc_rcm_init (_Q1, _Q2) (_L1, _L2) delta));;

let rec htai_add_qi x = hta_add_qi (eq_nat, hashable_nat) hashable_nat x;;

let rec htai_prodWR
  h1 h2 =
    hta_reindex (eqb eq_nat eq_nat, hashable hashable_nat hashable_nat)
      (eq_nat, hashable_nat)
      (hta_prodWR (eq_nat, hashable_nat) (eq_nat, hashable_nat)
        (eq_nat, hashable_nat) h1 h2);;

let rec sel_disjoint_witness
  sel1 mem2 s1 s2 = sel1 s1 (fun x -> (if mem2 x s2 then Some x else None));;

let rec hh_disjoint_witness (_A1, _A2)
  a = sel_disjoint_witness (hs_sel _A2) (hs_memb (_A1, _A2)) a;;

let rec brec_initial (_Q1, _Q2) (_L1, _L2)
  qi delta =
    let iq = brc_iq (_Q1, _Q2) delta in
    (brec_iqm (_Q1, _Q2) _L2 delta,
      (hs_to_fifo _Q2 iq,
        (brc_rcm_init (_Q1, _Q2) (_L1, _L2) delta,
          hh_disjoint_witness (_Q1, _Q2) iq qi)));;

let rec hta_add_rule (_Q1, _Q2) (_L1, _L2)
  r h = init_hta (hta_Qi h) (ls_ins (eq_ta_rulea _Q1 _L1) r (hta_delta h));;

let rec htai_add_rule
  x = hta_add_rule (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;;

let rec hta_bwd_reduce (_A1, _A2) (_B1, _B2)
  h = let rqrm = build_rqrm (_A1, _A2) (_B1, _B2) (hta_delta h) in
      hta_reduce (_A1, _A2) _B1 h
        (fst (whilea (brc_cond _A2 _B2) (brc_step (_A1, _A2) (_B1, _B2) rqrm)
               (brc_initial (_A1, _A2) (_B1, _B2) (hta_delta h))));;

let rec htai_bwd_reduce
  x = hta_bwd_reduce (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;;

let rec htai_ensure_idx_f x = hta_ensure_idx_f eq_nat (eq_nat, hashable_nat) x;;

let rec htai_ensure_idx_s x = hta_ensure_idx_s (eq_nat, hashable_nat) eq_nat x;;

let rec htai_ensure_idx_sf
  x = hta_ensure_idx_sf (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;;

let rec hta_is_empty_witness (_B1, _B2) (_A1, _A2)
  h = let rqrm = build_rqrm (_B1, _B2) (_A1, _A2) (hta_delta h) in
      let a =
        whilea (brec_cond _B1) (brec_step (_B1, _B2) (_A1, _A2) rqrm (hta_Qi h))
          (brec_initial (_B1, _B2) (_A1, _A2) (hta_Qi h) (hta_delta h))
        in
      let (q, aa) = a in
      let (uu, ab) = aa in
      let (uua, ac) = ab in
      (match ac with None -> None | Some qa -> hm_lookup (_B1, _B2) qa q);;

let rec htai_is_empty_witness
  x = hta_is_empty_witness (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;;

end;; (*struct Ta*)
